// FILENAME:	DM_Rude_Awakening.cs 
//
// AUTHORS:  	Gen. Stormtrooper
//------------------------------------------------------------------------------

$missionName = "DM_Rude_Awakening";

exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");

function setDefaultMissionOptions()
{
	$server::TeamPlay = false;
	$server::AllowDeathmatch = true;
	$server::AllowTeamPlay = true;	

   // what can the client choose for a team
	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = true;
	$server::AllowTeamYellow = false;
	$server::AllowTeamPurple = false;

   // what can the server admin choose for available teams
   $server::disableTeamRed = false;
   $server::disableTeamBlue = false;
   $server::disableTeamYellow = true;
   $server::disableTeamPurple = true;
}

Pilot DoomTrooper
{
   id = 28;
   name = "You're All Dead!";
   skill = 1.3;
   accuracy = 2.0;
   aggressiveness = 2.0;
   activateDist = 750;
   deactivateBuff = 100.0;
   targetFreq = 2.0;
   trackFreq = 0.0;
   fireFreq = 0.1;
   LOSFreq = 0.1;
   orderFreq = 2.0;
};

function Power::trigger::onContact(%trigger, %guy)
{
   healObject(%guy, -30);
   violate(%guy);
}

function tomb2enter::trigger::onContact(%trigger, %guy)
{
   setPosition(%guy, 10, 9236, 20);
}

function tomb2exit::trigger::onContact(%trigger, %guy)
{
   setPosition(%guy, -8, 9236, 170);
}

function tomb1enter::trigger::onContact(%trigger, %guy)
{
   setPosition(%guy, -488, 8667, 257);
}

function tomb1exit::trigger::onContact(%trigger, %guy)
{
   setPosition(%guy, -406, 8667, 250);
}

function begin::structure::onAttacked(%attacked, %attacker)
{
	if($curse == off)
	{
		%hunter = getObjectId("Missiongroup\\hunter");
		%death = getObjectId("Missiongroup\\death");
		setTeam(%hunter, *IDSTR_TEAM_PURPLE);
		setTeam(%death, *IDSTR_TEAM_PURPLE);
		setHostile(*IDSTR_TEAM_PURPLE, *IDSTR_TEAM_RED);
		setHostile(*IDSTR_TEAM_RED, *IDSTR_TEAM_PURPLE);
   		dropPod(-232, 9180, 3000, -232, 9180, 174, %hunter);
     	      dropPod(-272, 9180, 3000, -282, 9160, 300, %death);
	}
   $curse = on;
}

function onMissionStart()
{
	$curse = off;
	$hunter = live;
	$death = live;
	desertSounds();
}

function hunter::vehicle::onDestroyed(%d, %r)
{
   $hunter = dead;
	if($death == dead)
	{
		schedule( "missionEndConditionMet();", 1.6 );
	}
}

function death::vehicle::onDestroyed(%d, %r)
{
   $death = dead;
	if($hunter == dead)
	{
		schedule( "missionEndConditionMet();", 1.6 );
	}
}

function onMissionLoad()
{
	cdAudioCycle(Gnash, Cloudburst, Cyberntx); 
}

function player::onAdd(%this)
{
  say(%this, 0, "Welcome to DeathMatch Rude Awakening! You can download this & other missions made by Gen. Stormtrooper [M.I.B.] in the \"MIB Map Packs\" at www.starsiegeplayers.com or on the MIB Website at www.starsiegemeninblack.cjb.net.");
}
