// FILENAME:	DM_SS_Bowling.cs
//
// AUTHOR:  	Gen. Stormtrooper [M.I.B.] and Gen. Powio [M.I.B.]
//------------------------------------------------------------------------------

// this var 
$missionName = "DM_SS_Bowling";

exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");

function setDefaultMissionOptions()
{
	$server::TeamPlay = false;
	$server::AllowDeathmatch = true;
	$server::AllowTeamPlay = true;	
	
	$server::AllowTeamRed = false;
	$server::AllowTeamBlue = true;
	$server::AllowTeamYellow = true;
	$server::AllowTeamPurple = false;

   $server::disableTeamRed = true;
   $server::disableTeamBlue = false;
   $server::disableTeamYellow = false;
   $server::disableTeamPurple = true;
}

function onMissionStart()
{
	iceSounds();
	avalancheSounds();
	meteorSounds();
	earthquakeSounds();
}

function vehicle::onDestroyed(%destroyed, %destroyer)
{
   %p1 = playerManager::vehicleIdToPlayerNum(%destroyer);
   %p2 = playerManager::vehicleIdToPlayerNum(%destroyed);
   %message = getFancyDeathMessage(getHUDName(%destroyed), getHUDName(%destroyer));
   if(%p2.beingBowled == True) // I hate this kind of script >.< at least it's an instant death though. Good thing you're not playing with Ion Cannons.
   {
	%him = getHUDName(%destroyed);
      %dude = getName(%p2.BeingBowledBy);
      %Winner = %p2.BeingBowledBy; // I have a suspicion that dual dot-variables (%var1.name1.name2) won't work =\
      if(%Winner != %p2) // Don't give the dude a kill for themself if they bowl themselves over ~_^
      {
         %Winner.Kills = %Winner.Kills + 1;
      }
      // Took out the deaths part, since the target will be dying as it is now.
	say(0,0, %him@" has been destroyed by "@%dude@"'s bowling ball."); // Fixed a typo and tightened things up a li'l =)
   }
   else if(%message!="")
   {
      %p1.Kills = %p1.Kills + 1;
	say(0, 0, %message);
   }
   %p2.Deaths = %p2.Deaths + 1;
}

function vehicle::onAdd(%this)
{
   %p = playerManager::vehicleIdToPlayerNum(%this);
   %p.beingBowled = ""; // Unlock that person's destroyed state (Normal death or bowling ball death)
   %this.status = "ready";
}

function player::onAdd(%this)
{
   %this.score = 0;
   %this.kills = 0;
   %this.deaths = 0;
   say(%this, 0, "Welcome to DeathMatch Starsiege Bowling! Scan a person to fire a bowling ball at them. You can download this & other missions made by Gen. Stormtrooper [M.I.B.] and Gen. Powio [M.I.B.] in the \"MIB Map Packs\" at www.starsiegeplayers.com or on the MIB Website at www.starsiegemeninblack.cjb.net.");
}

function onMissionLoad()
{
   cdAudioCycle("Gnash", "Cloudburst", "Cyberntx"); 
}

function vehicle::onScan(%scanned, %scanner)
{
	if((%scanner.status == "ready") && (getHUDName(%scanner) == "Com. Sentinal [M.I.B.]"))
	{
      	roll2(%scanner, %scanned);
      	%scanner.status = "unready";
	}
	else if((%scanner.status == "ready") && (getHUDName(%scanner) == "Gen. Raven [M.I.B.]"))
	{
      	roll2(%scanner, %scanned);
      	%scanner.status = "unready";
	}
	else if(%scanner.status == "ready")
	{
      	roll(%scanner, %scanned);
      	%scanner.status = "unready";
	}

}

function roll(%roller, %rolled)
{
   %player = playerManager::vehicleIdToPlayerNum(%roller); // Don't forget the player number! ^_^
   %x = getPosition(%roller, x);
   %y = getPosition(%roller, y);
   %z = (getTerrainHeight(%x, %y) + 55 );
   %x1 = getPosition(%rolled, x);
   %y1 = getPosition(%rolled, y);
   %player.ball = loadObject("ball", "multiplayer/ball.tmp"); // All object properties are retained in the .tmp file, so staticShape isn't needed, nor will it work. Btw, watch it here, you had roller.ball instead of player.ball... and putting two slashes makes a comment, multiplayer//ball.tmp won't work then [ =( ] use multiplayer/ball.tmp insead [ =) ]
   setPosition(%player.ball,%x,%y,%z); // Setting the position of the new object
   %increments = getDistance(%roller,%rolled) / 2.8; // 100.8kM/hr I'm not a math expert, I just get to understand what Raven's doing in his scripts.
   %xDist = %x1 - %x; // Maybe the numbers between %x and %x1/2 shouldn't have been changed =)
   %yDist = %y1 - %y; // Ditto here.
   %xOffset = %xDist / %increments;
   %yOffset = %yDist / %increments;
   schedule("repulse(" @ %player @ ", " @ %player.ball @ ", " @ %xOffset @ ", " @ %yOffset @ ", " @ %increments @ ");", 0.1); //Now moves every 10th of a second, instead of after every whole second.
}

function roll2(%roller, %rolled)
{
   %player = playerManager::vehicleIdToPlayerNum(%roller); // Don't forget the player number! ^_^
   %x = getPosition(%roller, x);
   %y = getPosition(%roller, y);
   %z = (getTerrainHeight(%x, %y) + 5 );
   %x1 = getPosition(%rolled, x);
   %y1 = getPosition(%rolled, y);
   %player.ball = loadObject("ball", "multiplayer/ball2.tmp"); // All object properties are retained in the .tmp file, so staticShape isn't needed, nor will it work. Btw, watch it here, you had roller.ball instead of player.ball... and putting two slashes makes a comment, multiplayer//ball.tmp won't work then [ =( ] use multiplayer/ball.tmp insead [ =) ]
   setPosition(%player.ball,%x,%y,%z); // Setting the position of the new object
   %increments = getDistance(%roller,%rolled) / 2.8; // 100.8kM/hr I'm not a math expert, I just get to understand what Raven's doing in his scripts.
   %xDist = %x1 - %x; // Maybe the numbers between %x and %x1/2 shouldn't have been changed =)
   %yDist = %y1 - %y; // Ditto here.
   %xOffset = %xDist / %increments;
   %yOffset = %yDist / %increments;
   schedule("repulse(" @ %player @ ", " @ %player.ball @ ", " @ %xOffset @ ", " @ %yOffset @ ", " @ %increments @ ");", 0.1); //Now moves every 10th of a second, instead of after every whole second.
}

function repulse(%player, %spyder, %xOffset, %yOffset, %increments)
{
   if(%increments >= 1)
   {
      %increments--;
      %x = getPosition(%spyder, x) + %xOffset;
      %y = getPosition(%spyder, y) + %yOffset;
      %z = getTerrainHeight(%x, %y) + 5; // Added the +5
	%ran = randomInt(1, 360);
      setPosition(%spyder, %x, %y, %z, 0, %ran);
      schedule("repulse(" @ %player @ ", " @ %spyder @ ", " @ %xOffset @ ", " @ %yOffset @ ", " @ %increments @ ");", 0.1);
   }
   else
   {
      if(%increments < 1) // Never trust the numbers unless yer gunna take the time to do the math...
      {
 	   playSound(0, "sfx_fog.wav", IDPRF_2D);

         // This was messy =)
         %playerCount = playerManager::getPlayerCount();
         for(%i=0; %i < %playerCount ; %i++)
         {
            %person = playerManager::getPlayerNum( %i );
            %john = playerManager::playerNumToVehicleId(%person);
		if(getDistance(%john, %spyder) <= 250)
		{
                  %person.beingBowled = True; // We don't want to take chances if someone attacked that person earlier and gets the kill.
                  %person.beingBowledBy = %player; // Kills are added up later =) (See vehicle::onDestroyed)
                  echo(%person.beingBowledBy);
		}
	   }
  	   damageArea(%spyder, 0, 0, 0, 250, 2500); // Looks like you didn't have the problem I was expecting after all..
         deleteObject(%spyder);
 	   %vehicle = playerManager::PlayerNumTovehicleId(%player);
	   %vehicle.status = "ready";
      }
   }
}

// At the moment the variables for the default scoreboards are unknown, so we can't use %player.score to get someone's
// actual score (that doesn't include all the scripting going on here). The formula for the default scoreboard is
// ((%p.kills * 3) - (%p.deaths * 2)) and then you could always add to it.

function getScore(%playerId)
{
   return((%playerId.Kills * 3) - (%playerId.Deaths * 2));
}

function getKills(%playerId)
{
   return(%playerId.kills);
}

function getDeaths(%playerId)
{
   return(%playerId.deaths);
}

function initScoreBoard()
{
   deleteVariables("$ScoreBoard::PlayerColumn*");
   deleteVariables("$ScoreBoard::TeamColumn*");

   // Player ScoreBoard column headings
   $ScoreBoard::PlayerColumnHeader1 = *IDMULT_SCORE_SQUAD;
   $ScoreBoard::PlayerColumnHeader2 = "Score";
   $ScoreBoard::PlayerColumnHeader3 = *IDMULT_SCORE_KILLS;
   $ScoreBoard::PlayerColumnHeader4 = *IDMULT_SCORE_DEATHS;
                  
   // Player ScoreBoard column functions
   $ScoreBoard::PlayerColumnFunction1 = "getSquad";
   $ScoreBoard::PlayerColumnFunction2 = "getScore"; //Shortened the names of these, keep them this way unless you plan to
   $ScoreBoard::PlayerColumnFunction3 = "getKills"; //overwrite their commands.
   $ScoreBoard::PlayerColumnFunction4 = "getDeaths";
   serverInitScoreBoard();

}

initScoreBoard();