// FILENAME:	ION_Sand_Dunes.cs
//
// AUTHOR:  	Gen. Raven [M.I.B.]
//
// RANDOM QUOTE:  "There is no spoon."
//                       - Neo from "The Matrix" 
//------------------------------------------------------------------------------
// Stealth Detection - Set to true & players with a "/" in front of their
// will be detected when they join or leave the server.

$stealthDetect = true;    //Set to false to turn off stealth detection

//------------------------------------------------------------------------------
$missionName = "ION_Sand_Dunes";

exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");

function setDefaultMissionOptions()
{
	$server::TeamPlay = false;
	$server::AllowDeathmatch = true;
	$server::AllowTeamPlay = true;	

   // what can the client choose for a team
	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = true;
	$server::AllowTeamYellow = true;
	$server::AllowTeamPurple = true;

   // what can the server admin choose for available teams
   $server::disableTeamRed = false;
   $server::disableTeamBlue = false;
   $server::disableTeamYellow = false;
   $server::disableTeamPurple = false;
}

function onMissionStart()
{
	desertSounds();

      // Sand Dunes special stuff
      $boom1 = "MissionGroup/Anims/boom1";
      $boom2 = "MissionGroup/Anims/boom2";
      $boom3 = "MissionGroup/Anims/boom3";
      $boom4 = "MissionGroup/Anims/boom4";
      $boom5 = "MissionGroup/Anims/boom5";
      $boom6 = "MissionGroup/Anims/boom6";
      $boom7 = "MissionGroup/Anims/boom7";
      $boom8 = "MissionGroup/Anims/boom8";
      $boom9 = "MissionGroup/Anims/boom9";
      $boom10 = "MissionGroup/Anims/boom10";
      $boom11 = "MissionGroup/Anims/boom11";
      $boom12 = "MissionGroup/Anims/boom12";
      $boom13 = "MissionGroup/Anims/boom13";
      $boom14 = "MissionGroup/Anims/boom14";
      $boom15 = "MissionGroup/Anims/boom15";      
}

function onMissionLoad()
{
   cdAudioCycle("Mechsoul", "CloudBurst", "Terror", "Watching", "Cyberntx");
   setGameInfo("<F2>GAME TYPE:<F0>  DeathMatch\n\n<F2>MISSION:<F0>  ION_Sand_Dunes\n\nWelcome to Ion Cannon Deathmatch! You can fire your Ion Cannon by scanning vehicles or structures, or by spotting them with LTADs. Your Ion Cannon must recharge for 90 seconds after each use. You can download ION_Sand_Dunes & other missions made by Gen. Raven [M.I.B.] in the \"MIB Map Packs\" at www.starsiegeplayers.com or on the MIB Website at www.starsiegemeninblack.cjb.net.");
   //reset the boomkills
   %count = playerManager::getPlayerCount();
   for(%i = 0; %i < %count; %i++)
   {
      %player = playerManager::getPlayerNum(%i);
      %player.boomkill = 0;
   }
}

function player::onadd(%player)
{
   if(($stealthDetect == true)&&(strAlign(1, left, getname(%player))=="/"))
   {
        say(0,0,"<f4>"@getname(%player)@" joined the game","alarm2.wav");
        messagebox(%player,"This server is equipped with an anti-stealth detection system. The slash on your name has been detected. All players have been alerted to your presence.");
        say(%player,0,"Welcome to Ion Cannon Deathmatch! You can fire your Ion Cannon by scanning vehicles or structures, or by spotting them with LTADs. Your Ion Cannon must recharge for 90 seconds after each use. You can download ION_Sand_Dunes & other missions made by Gen. Raven [M.I.B.] in the \"MIB Map Packs\" at www.starsiegeplayers.com or on the MIB Website at www.starsiegemeninblack.cjb.net.");
   }
   else
   {
      say(%player,0,"Welcome to Ion Cannon Deathmatch! You can fire your Ion Cannon by scanning vehicles or structures, or by spotting them with LTADs. Your Ion Cannon must recharge for 90 seconds after each use. You can download ION_Sand_Dunes & other missions made by Gen. Raven [M.I.B.] in the \"MIB Map Packs\" at www.starsiegeplayers.com or on the MIB Website at www.starsiegemeninblack.cjb.net.");
   }
   %player.boomkill = 0;
}

function player::onremove(%player)
{
   if(($stealthDetect == true)&&(strAlign(1, left, getname(%player))=="/"))
   {
      say(0,0,"<f4>"@getname(%player)@" left the game","alarm2.wav");
   }
}

function vehicle::onadd(%vehicleId)
{
   %player = playermanager::vehicleIdtoPlayerNum(%vehicleId);
   %vehicleId.ready = true;
   sethudtimer(0,0,"Ion Cannon Online",2,%player);
}

function vehicle::onspot(%spotter,%target)
{
    %player = playermanager::vehicleIdtoPlayerNum(%spotter);
    %player2 = playermanager::vehicleIdtoPlayerNum(%target);
    if($server::Teamplay==false)
    {
       if(%target!="")
       {
           if(%spotter.ready==true)
           {
               %target.killer = getname(%spotter);
               %player2.killer2 = %player;
               %spotter.ready = false;
               %spotterX = getposition(%spotter,x);
               %spotterY = getposition(%spotter,y);
               %spotterZ = getposition(%spotter,z)+10;
               %targetX = getposition(%target,x);
               %targetY = getposition(%target,y);
               %targetZ = getposition(%target,z);
               droppod(%spotterX,%spotterY,%spotterZ,%targetX,%targetY,%targetZ);
               %distance = getdistance(%spotter,%target);
               %time = %distance / 400; //400 m/s (speed of drop pod)
               schedule("damagearea("@%target@",0,0,0,150,875);",%time);
               schedule("playSound(%player2, \"explo3.wav\", IDPRF_2D);",%time);
               %spotter.firetime = getcurrenttime();
               schedule("ready("@%spotter@");",90);
               sethudtimer(90,-1,"Ion Cannon Recharging",2,%player);
               playSound(%player, "sfx_shrk.wav", IDPRF_2D);
           }
           else if(%spotter.ready==false)
           {
               %spotter.nowtime  = getcurrenttime();
               %spotter.timecharged = %spotter.nowtime - %spotter.firetime;
               %spotter.timeleft = 90 - %spotter.timecharged;
               say(%player,%player,"<f1>Ion Cannon charging - " @ %spotter.timeleft @ " seconds remaining.");
           }
       }
    }
    else if(($server::TeamPlay == true) && (getTeam(%spotter) != getTeam(%target)))
    {
       if(%target!="")
       {
           if(%spotter.ready==true)
           {
               %target.killer = getname(%spotter);
               %player2.killer2 = %player;
               %spotter.ready = false;
               %spotterX = getposition(%spotter,x);
               %spotterY = getposition(%spotter,y);
               %spotterZ = getposition(%spotter,z)+10;
               %targetX = getposition(%target,x);
               %targetY = getposition(%target,y);
               %targetZ = getposition(%target,z);
               droppod(%spotterX,%spotterY,%spotterZ,%targetX,%targetY,%targetZ);
               %distance = getdistance(%spotter,%target);
               %time = %distance / 400; //400 m/s (speed of drop pod)
               schedule("damagearea("@%target@",0,0,0,150,875);",%time);
               schedule("playSound(%player2, \"explo3.wav\", IDPRF_2D);",%time);
               %spotter.firetime = getcurrenttime();
               schedule("ready("@%spotter@");",90);
               sethudtimer(90,-1,"Ion Cannon Recharging",2,%player);
               playSound(%player, "sfx_shrk.wav", IDPRF_2D);
           }
           else if(%spotter.ready==false)
           {
               %spotter.nowtime  = getcurrenttime();
               %spotter.timecharged = %spotter.nowtime - %spotter.firetime;
               %spotter.timeleft = 90 - %spotter.timecharged;
               say(%player,%player,"<f1>Ion Cannon charging - " @ %spotter.timeleft @ " seconds remaining.");
           }
       }
   }          
   else
   {
      say(%player,%player,"<f5>You cannot fire on your own team!");
   } 
}

function vehicle::onscan(%scanned,%scanner)
{
    %player = playermanager::vehicleIdtoPlayerNum(%scanner);
    %player2 = playermanager::vehicleIdtoPlayerNum(%scanned);
    if($server::Teamplay==false)
    {
       if(%scanner.ready==true)
       {
           %scanned.killer = getname(%scanner);
           %player2.killer2 = %player;
           %scanner.ready = false;
           %scannerX = getposition(%scanner,x);
           %scannerY = getposition(%scanner,y);
           %scannerZ = getposition(%scanner,z)+10;
           %scannedX = getposition(%scanned,x);
           %scannedY = getposition(%scanned,y);
           %scannedZ = getposition(%scanned,z);
           droppod(%scannerX,%scannerY,%scannerZ,%scannedX,%scannedY,%scannedZ);
           %distance = getdistance(%scanner,%scanned);
           %time = %distance / 400; //400 m/s (speed of drop pod)
           schedule("damagearea("@%scanned@",0,0,0,150,875);",%time);
           schedule("playSound(%player2, \"explo3.wav\", IDPRF_2D);",%time);
           %scanner.firetime = getcurrenttime();
           schedule("ready2("@%scanner@");",90);
           sethudtimer(90,-1,"Ion Cannon Recharging",2,%player);
           playSound(%player, "sfx_shrk.wav", IDPRF_2D);
       }
       else if(%scanner.ready==false)
       {
           %scanner.nowtime  = getcurrenttime();
           %scanner.timecharged = %scanner.nowtime - %scanner.firetime;
           %scanner.timeleft = 90 - %scanner.timecharged;
           say(%player,%player,"<f1>Ion Cannon charging - " @ %scanner.timeleft @ " seconds remaining.");
       }
    }
    else if(($server::TeamPlay == true) && (getTeam(%scanner) != getTeam(%scanned)))
    {
       if(%scanner.ready==true)
       {
           %scanned.killer = getname(%scanner);
           %player2.killer2 = %player;
           %scanner.ready = false;
           %scannerX = getposition(%scanner,x);
           %scannerY = getposition(%scanner,y);
           %scannerZ = getposition(%scanner,z)+10;
           %scannedX = getposition(%scanned,x);
           %scannedY = getposition(%scanned,y);
           %scannedZ = getposition(%scanned,z);
           droppod(%scannerX,%scannerY,%scannerZ,%scannedX,%scannedY,%scannedZ);
           %distance = getdistance(%scanner,%scanned);
           %time = %distance / 400; //400 m/s (speed of drop pod)
           schedule("damagearea("@%scanned@",0,0,0,150,875);",%time);
           schedule("playSound(%player2, \"explo3.wav\", IDPRF_2D);",%time);
           %scanner.firetime = getcurrenttime();
           schedule("ready2("@%scanner@");",90);
           sethudtimer(90,-1,"Ion Cannon Recharging",2,%player);
           playSound(%player, "sfx_shrk.wav", IDPRF_2D);
       }
       else if(%scanner.ready==false)
       {
           %scanner.nowtime  = getcurrenttime();
           %scanner.timecharged = %scanner.nowtime - %scanner.firetime;
           %scanner.timeleft = 90 - %scanner.timecharged;
           say(%player,%player,"<f1>Ion Cannon charging - " @ %scanner.timeleft @ " seconds remaining.");
       }
   }
   else
   {
      say(%player,%player,"<f5>You cannot fire on your own team!");
   } 
}

function structure::onscan(%scanned,%scanner)
{
    %player = playermanager::vehicleIdtoPlayerNum(%scanner);
    if(%scanner.ready==true)
    {
        %scanner.ready = false;
        %scannerX = getposition(%scanner,x);
        %scannerY = getposition(%scanner,y);
        %scannerZ = getposition(%scanner,z)+10;
        %scannedX = getposition(%scanned,x);
        %scannedY = getposition(%scanned,y);
        %scannedZ = getposition(%scanned,z);
        droppod(%scannerX,%scannerY,%scannerZ,%scannedX,%scannedY,%scannedZ);
        %distance = getdistance(%scanner,%scanned);
        %time = %distance / 400; //400 m/s (speed of drop pod)
        schedule("damagearea("@%scanned@",0,0,0,150,875);",%time);
        schedule("damageobject("@%scanned@",100000);",%time);
        %scanner.firetime = getcurrenttime();
        schedule("ready2("@%scanner@");",90);
        sethudtimer(90,-1,"Ion Cannon Recharging",2,%player);
        playSound(%player, "sfx_shrk.wav", IDPRF_2D);
    }
    else if(%scanner.ready==false)
    {
        %scanner.nowtime  = getcurrenttime();
        %scanner.timecharged = %scanner.nowtime - %scanner.firetime;
        %scanner.timeleft = 90 - %scanner.timecharged;
        say(%player,%player,"<f1>Ion Cannon charging - " @ %scanner.timeleft @ " seconds remaining.");
    }
}

function ready(%spotter)
{  
      %spotter.ready = true;      
}

function ready2(%scanner)
{  
      %scanner.ready = true;      
}

function vehicle::onDestroyed(%destroyed, %destroyer)
{
   // left over from missionStdLib.cs
   vehicle::onDestroyedLog(%destroyed, %destroyer);
   
   %player = playermanager::vehicleIdtoPlayerNum(%destroyer);
   %player2 = playermanager::vehicleIdtoPlayerNum(%destroyed);
   if(%player == 0)
   {
      %random = randomInt(0,2); 
      if(%destroyed.killer != "")
      {
         if(%random == 0)
         {
            say(0,2,"<f0>" @ %destroyed.killer @ " annihilated " @ gethudname(%destroyed) @ " with his Ion Cannon.","sfx_fog.wav");
         }
         else if(%random == 1)
         {
            say(0,2,"<f0>" @ gethudname(%destroyed) @ " was destroyed by " @ %destroyed.killer @ "'s Ion Cannon.","sfx_fog.wav");
         }
         else if(%random == 2)
         {
            say(0,2,"<f0>" @ gethudname(%destroyed) @ " didnt see " @ %destroyed.killer @ "'s Ion Cannon until it was too late.","sfx_fog.wav");    
         }
      }
      else if(%destroyed.killer == "")
      {
         say(0,2,"<f0>" @ gethudname(%destroyed) @ " got caught in an ionic shockwave.","sfx_fog.wav");    
      }
      
      %killer = %player2.killer2;
      %killer.boomkill = %killer.boomkill + 3;
   }
   else
   {   
      // this is weird but %destroyer isn't necessarily a vehicle
      %message = getFancyDeathMessage(getHUDName(%destroyed), getHUDName(%destroyer));
      if(%message != "")
      {
         say( 0, 0, %message);
      }
      // enforce the rules
      if($server::TeamPlay == true)
      {
         if((getTeam(%destroyed) == getTeam(%destroyer))&&(%destroyed != %destroyer))
         {
            antiTeamKill(%destroyer);
         }
      }   
   }
}

function getPlayerScore(%player)
{
   return((getKills(%player) * $killPoints) - (getDeaths(%player) * $deathPoints)) + %player.boomkill;
}

// Sand Dunes special stuff
function boom1::structure::ondestroyed(%destroyed,%destroyer)
{
   %player = playermanager::vehicleIdtoPlayerNum(%destroyer);
   if(%player==0)
   {
      %destroyed.x = getposition(%destroyed,x);
      %destroyed.y = getposition(%destroyed,y);
      %destroyed.z = getTerrainHeight(%destroyed.x,%destroyed.y);
      setposition($boom1,%destroyed.x,%destroyed.y,%destroyed.z);
      playAnimSequence($boom1,0,true);
      schedule("deleteobject($boom1);",1.067);
   }
   else
   {
      schedule("deleteobject($boom1);",1.067);
   }
}

function boom2::structure::ondestroyed(%destroyed,%destroyer)
{
   %player = playermanager::vehicleIdtoPlayerNum(%destroyer);
   if(%player==0)
   {
      %destroyed.x = getposition(%destroyed,x);
      %destroyed.y = getposition(%destroyed,y);
      %destroyed.z = getTerrainHeight(%destroyed.x,%destroyed.y);
      setposition($boom2,%destroyed.x,%destroyed.y,%destroyed.z);
      playAnimSequence($boom2,0,true);
      schedule("deleteobject($boom2);",1.067);
   }
   else
   {
      schedule("deleteobject($boom2);",1.067);
   }
}

function boom3::structure::ondestroyed(%destroyed,%destroyer)
{
   %player = playermanager::vehicleIdtoPlayerNum(%destroyer);
   if(%player==0)
   {
      %destroyed.x = getposition(%destroyed,x);
      %destroyed.y = getposition(%destroyed,y);
      %destroyed.z = getTerrainHeight(%destroyed.x,%destroyed.y);
      setposition($boom3,%destroyed.x,%destroyed.y,%destroyed.z);
      playAnimSequence($boom3,0,true);
      schedule("deleteobject($boom3);",1.067);
   }
   else
   {
      schedule("deleteobject($boom3);",1.067);
   }
}

function boom4::structure::ondestroyed(%destroyed,%destroyer)
{
   %player = playermanager::vehicleIdtoPlayerNum(%destroyer);
   if(%player==0)
   {
      %destroyed.x = getposition(%destroyed,x);
      %destroyed.y = getposition(%destroyed,y);
      %destroyed.z = getTerrainHeight(%destroyed.x,%destroyed.y);
      setposition($boom4,%destroyed.x,%destroyed.y,%destroyed.z);
      playAnimSequence($boom4,0,true);
      schedule("deleteobject($boom4);",1.067);
   }
   else
   {
      schedule("deleteobject($boom4);",1.067);
   }
}

function boom5::structure::ondestroyed(%destroyed,%destroyer)
{
   %player = playermanager::vehicleIdtoPlayerNum(%destroyer);
   if(%player==0)
   {
      %destroyed.x = getposition(%destroyed,x);
      %destroyed.y = getposition(%destroyed,y);
      %destroyed.z = getTerrainHeight(%destroyed.x,%destroyed.y);
      setposition($boom5,%destroyed.x,%destroyed.y,%destroyed.z);
      playAnimSequence($boom5,0,true);
      schedule("deleteobject($boom5);",1.067);
   }
   else
   {
      schedule("deleteobject($boom5);",1.067);
   }
}

function boom6::structure::ondestroyed(%destroyed,%destroyer)
{
   %player = playermanager::vehicleIdtoPlayerNum(%destroyer);
   if(%player==0)
   {
      %destroyed.x = getposition(%destroyed,x);
      %destroyed.y = getposition(%destroyed,y);
      %destroyed.z = getTerrainHeight(%destroyed.x,%destroyed.y);
      setposition($boom6,%destroyed.x,%destroyed.y,%destroyed.z);
      playAnimSequence($boom6,0,true);
      schedule("deleteobject($boom6);",1.067);
   }
   else
   {
      schedule("deleteobject($boom6);",1.067);
   }
}

function boom7::structure::ondestroyed(%destroyed,%destroyer)
{
   %player = playermanager::vehicleIdtoPlayerNum(%destroyer);
   if(%player==0)
   {
      %destroyed.x = getposition(%destroyed,x);
      %destroyed.y = getposition(%destroyed,y);
      %destroyed.z = getTerrainHeight(%destroyed.x,%destroyed.y);
      setposition($boom7,%destroyed.x,%destroyed.y,%destroyed.z);
      playAnimSequence($boom7,0,true);
      schedule("deleteobject($boom7);",1.067);
   }
   else
   {
      schedule("deleteobject($boom7);",1.067);
   }
}

function boom8::structure::ondestroyed(%destroyed,%destroyer)
{
   %player = playermanager::vehicleIdtoPlayerNum(%destroyer);
   if(%player==0)
   {
      %destroyed.x = getposition(%destroyed,x);
      %destroyed.y = getposition(%destroyed,y);
      %destroyed.z = getTerrainHeight(%destroyed.x,%destroyed.y);
      setposition($boom8,%destroyed.x,%destroyed.y,%destroyed.z);
      playAnimSequence($boom8,0,true);
      schedule("deleteobject($boom8);",1.067);
   }
   else
   {
      schedule("deleteobject($boom8);",1.067);
   }
}

function boom9::structure::ondestroyed(%destroyed,%destroyer)
{
   %player = playermanager::vehicleIdtoPlayerNum(%destroyer);
   if(%player==0)
   {
      %destroyed.x = getposition(%destroyed,x);
      %destroyed.y = getposition(%destroyed,y);
      %destroyed.z = getTerrainHeight(%destroyed.x,%destroyed.y);
      setposition($boom9,%destroyed.x,%destroyed.y,%destroyed.z);
      playAnimSequence($boom9,0,true);
      schedule("deleteobject($boom9);",1.067);
   }
   else
   {
      schedule("deleteobject($boom9);",1.067);
   }
}

function boom10::structure::ondestroyed(%destroyed,%destroyer)
{
   %player = playermanager::vehicleIdtoPlayerNum(%destroyer);
   if(%player==0)
   {
      %destroyed.x = getposition(%destroyed,x);
      %destroyed.y = getposition(%destroyed,y);
      %destroyed.z = getTerrainHeight(%destroyed.x,%destroyed.y);
      setposition($boom10,%destroyed.x,%destroyed.y,%destroyed.z);
      playAnimSequence($boom10,0,true);
      schedule("deleteobject($boom10);",1.067);
   }
   else
   {
      schedule("deleteobject($boom10);",1.067);
   }
}

function boom11::structure::ondestroyed(%destroyed,%destroyer)
{
   %player = playermanager::vehicleIdtoPlayerNum(%destroyer);
   if(%player==0)
   {
      %destroyed.x = getposition(%destroyed,x);
      %destroyed.y = getposition(%destroyed,y);
      %destroyed.z = getTerrainHeight(%destroyed.x,%destroyed.y);
      setposition($boom11,%destroyed.x,%destroyed.y,%destroyed.z);
      playAnimSequence($boom11,0,true);
      schedule("deleteobject($boom11);",1.067);
   }
   else
   {
      schedule("deleteobject($boom11);",1.067);
   }
}

function boom12::structure::ondestroyed(%destroyed,%destroyer)
{
   %player = playermanager::vehicleIdtoPlayerNum(%destroyer);
   if(%player==0)
   {
      %destroyed.x = getposition(%destroyed,x);
      %destroyed.y = getposition(%destroyed,y);
      %destroyed.z = getTerrainHeight(%destroyed.x,%destroyed.y);
      setposition($boom12,%destroyed.x,%destroyed.y,%destroyed.z);
      playAnimSequence($boom12,0,true);
      schedule("deleteobject($boom12);",1.067);
   }
   else
   {
      schedule("deleteobject($boom12);",1.067);
   }
}

function boom13::structure::ondestroyed(%destroyed,%destroyer)
{
   %player = playermanager::vehicleIdtoPlayerNum(%destroyer);
   if(%player==0)
   {
      %destroyed.x = getposition(%destroyed,x);
      %destroyed.y = getposition(%destroyed,y);
      %destroyed.z = getTerrainHeight(%destroyed.x,%destroyed.y);
      setposition($boom13,%destroyed.x,%destroyed.y,%destroyed.z);
      playAnimSequence($boom13,0,true);
      schedule("deleteobject($boom13);",1.067);
   }
   else
   {
      schedule("deleteobject($boom13);",1.067);
   }
}

function boom14::structure::ondestroyed(%destroyed,%destroyer)
{
   %player = playermanager::vehicleIdtoPlayerNum(%destroyer);
   if(%player==0)
   {
      %destroyed.x = getposition(%destroyed,x);
      %destroyed.y = getposition(%destroyed,y);
      %destroyed.z = getTerrainHeight(%destroyed.x,%destroyed.y);
      setposition($boom14,%destroyed.x,%destroyed.y,%destroyed.z);
      playAnimSequence($boom14,0,true);
      schedule("deleteobject($boom14);",1.067);
   }
   else
   {
      schedule("deleteobject($boom14);",1.067);
   }   
}

function boom15::structure::ondestroyed(%destroyed,%destroyer)
{
   %player = playermanager::vehicleIdtoPlayerNum(%destroyer);
   if(%player==0)
   {
      %destroyed.x = getposition(%destroyed,x);
      %destroyed.y = getposition(%destroyed,y);
      %destroyed.z = getTerrainHeight(%destroyed.x,%destroyed.y);
      setposition($boom15,%destroyed.x,%destroyed.y,%destroyed.z);
      playAnimSequence($boom15,0,true);
      schedule("deleteobject($boom15);",1.067);
   }
   else
   {
      schedule("deleteobject($boom15);",1.067);
   }
}