// FILENAME:	SS_Golf.cs
//
// AUTHOR:  	Com. Sentinal [M.I.B.]
//------------------------------------------------------------------------------

$missionName = "Starsiege Golf";

exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");

$server::HudMapViewOffsetX = -2444;
$server::HudMapViewOffsetY = 2165;

function setDefaultMissionOptions()
{
	$server::TeamPlay = true;
	$server::AllowDeathmatch = false;
	$server::AllowTeamPlay = true;	

   // what can the client choose for a team
	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = true;
	$server::AllowTeamYellow = false;
	$server::AllowTeamPurple = false;

   // what can the server admin choose for available teams
   $server::disableTeamRed = false;
   $server::disableTeamBlue = false;
   $server::disableTeamYellow = true;
   $server::disableTeamPurple = true;
}

$windspeed = 0;
$winddir = "N";
$drivespeed = 10;
$puttspeed = 5;

function onMissionStart()
{
   temperateSounds();
   $ball = getObjectId("Missiongroup\\ball");
   $flag0 = getObjectId("Missiongroup\\flag0");
   $flag1 = getObjectId("Missiongroup\\flag1");
   $flag2 = getObjectId("Missiongroup\\flag2");
   $flag3 = getObjectId("Missiongroup\\flag3");
   $flag4 = getObjectId("Missiongroup\\flag4");
   $flag5 = getObjectId("Missiongroup\\flag5");
   $flag6 = getObjectId("Missiongroup\\flag6");
   $flag7 = getObjectId("Missiongroup\\flag7");
   $flag8 = getObjectId("Missiongroup\\flag8");
   $flag9 = getObjectId("Missiongroup\\flag9");
   $flag10 = getObjectId("Missiongroup\\flag10");
   $flag11 = getObjectId("Missiongroup\\flag11");
   $flag12 = getObjectId("Missiongroup\\flag12");
   $flag13 = getObjectId("Missiongroup\\flag13");
   $flag14 = getObjectId("Missiongroup\\flag14");
   $flag15 = getObjectId("Missiongroup\\flag15");
   $flag16 = getObjectId("Missiongroup\\flag16");
   $flag17 = getObjectId("Missiongroup\\flag17");
   $flag18 = getObjectId("Missiongroup\\flag18");
   schedule("changeWind();", 10);
}

function player::onAdd(%player)
{
   say(%player, 0, "Welcome to Starsiege Golf! Check the game info tab for information on how to play. You can download this & other missions made by Com. Sentinal [M.I.B.] in the \"MIB Map Packs\" at www.starsiegeplayers.com or on the MIB Website at www.starsiegemeninblack.cjb.net.");
   %player.points = 0;
   %player.strokes = 0;
   %player.totalStrokes = 0;
}

function player::onRemove(%player)
{
   deleteObject(%player.ball);
}

function onMissionLoad()
{
   cdAudioCycle("Watching", "Purge", "Cyberntx", "Terror"); 
   setGameInfo("<F2>GAME TYPE:<F0>  Starsiege Golf\n\n<F2>MISSION:<F0>  SS_Golf\n\n<F2>CREATOR:<F0>  Com. Sentinal [M.I.B.]\n\nWelcome to Starsiege Golf! There is a hole at each of the nav markers, each of which is marked by a flag. You can play any hole at any time. Scan your ball to choose your golf club. Each club has a different range. Shoot your ball to hit it in the direction you are facing. Respawn if you wish to restart your game. Good Luck!\n\n<F2>DOWNLOAD INFO:<F0>\n\nYou can download this & other missions made by Com. Sentinal [M.I.B.] in the \"MIB Map Packs\" on the MIB Website at www.starsiegemeninblack.cjb.net.");
   %count = playerManager::getPlayerCount();
   for(%i = 0; %i < %count; %i++)
   {
      %player = playerManager::getPlayerNum(%i);
      %player.points = 0;
      %player.strokes = 0;
      %player.totalStrokes = 0;
   }
}

function vehicle::onAdd(%vehicleId)
{
   %player = playerManager::vehicleIdToPlayerNum(%vehicleId);
   setTeam(%vehicleId, *IDSTR_TEAM_BLUE);
   %player.club = 1000;
   %player.strokes = 0;
   %player.lock = false;
   %player.ball = copyObject($ball);   
   %player.msglock = false;
   setStaticShapeShortName(%player.ball, getName(%player) @ "'s Ball");
   setStaticShapeLongName(%player.ball, getName(%player) @ "'s Ball");
   teeOff(%vehicleId);
   say(%player, %player, "<F4>There is a hole at each of the nav markers, each of which is marked by a flag. You can play any hole at any time. Scan your ball to choose your golf club. Each club has a different range. Shoot your ball to hit it in the direction you are facing. Respawn if you wish to restart your game. Good Luck!");
}

function teeOff(%vehicleId)
{
   %player = playerManager::vehicleIdToPlayerNum(%vehicleId);
   %angle = radToDeg(getPosition(%vehicleId, rot));
   %xDist = 30 * cos(%angle + 90);
   %yDist = 30 * sin(%angle + 90);
   %x = getPosition(%vehicleId, x) + %xDist;
   %y = getPosition(%vehicleId, y) + %yDist;
   %z = getTerrainHeight(%x, %y) - 6;
   setPosition(%player.ball, %x, %y, %z);
   setShapeVisibility(%player.ball, true);
   %player.strokes = 0;
   %player.club = 1000;
}

function copyObject(%object)
{
   storeObject(%object, "copyObject.tmp");
   %copy = loadObject(getObjectName(%object), "copyObject.tmp");
   return %copy;
}

function structure::onScan(%scanned, %scanner)
{
   %player = playerManager::vehicleIdToPlayerNum(%scanner);
   if((getObjectName(%scanned)=="ball")&&(%scanned == %player.ball))
   {
      toggleClubs(%player);
   }
}

function toggleClubs(%player)
{
   if(%player.club == 1000)
   {
      %player.club = 750;
      say(%player, %player, "<F1>Select Club: Long-range driver (750m avg)");
   }
   else if(%player.club == 750)
   {
      %player.club = 500;
      say(%player, %player, "<F1>Select Club: Medium-range driver (500m avg)");
   }
   else if(%player.club == 500)
   {
      %player.club = 300;
      say(%player, %player, "<F1>Select Club: Short-range driver (300m avg)");
   }
   else if(%player.club == 300)
   {
      %player.club = 200;
      say(%player, %player, "<F1>Select Club: Close-range driver (200m avg)");
   }
   else if(%player.club == 200)
   {
      %player.club = 100;
      say(%player, %player, "<F1>Select Club: Long-range putter (100m avg)");
   }
   else if(%player.club == 100)
   {
      %player.club = 75;
      say(%player, %player, "<F1>Select Club: Medium-range putter (75m avg)");
   }
   else if(%player.club == 75)
   {
      %player.club = 50;
      say(%player, %player, "<F1>Select Club: Short-range putter (50m avg)");
   }
   else if(%player.club == 50)
   {
      %player.club = 25;
      say(%player, %player, "<F1>Select Club: Close-range putter (25m avg)");
   }
   else if(%player.club == 25)
   {
      %player.club = 10;
      say(%player, %player, "<F1>Select Club: Point-blank range putter (10m avg)");
   }
   else if(%player.club == 10)
   {
      %player.club = 1000;
      say(%player, %player, "<F1>Select Club: Extended-range driver (1000m avg)");
   }
}

function structure::onAttacked(%attacked, %attacker)
{
   %player = playerManager::vehicleIdToPlayerNum(%attacker);
   if(getObjectName(%attacked)=="ball")
   {
      if(%attacked == %player.ball)
      {
         if(%player.lock == false)
         {
            %player.lock = true;
            hitBall(%player);
         }
      }
      else
      {
         if(%player.msglock == false)
         {
            %player.msglock = true;
            say(%player, %player, "<F5>That is not your golf ball!");
            schedule("resetMsgLock(" @ %player @ ");", 2);
         }
      }
   }
}

function resetMsgLock(%player)
{
   %player.msglock = false;
}

function hitBall(%player)
{
   playSound(%player, "sfx_prob.wav", IDPRF_2D);
   %player.strokes++;
   %player.totalStrokes++;
   if(%player.club <= 100)
   {
      %vehicleId = playerManager::playerNumToVehicleId(%player);
      %angle = radToDeg(getPosition(%vehicleId, rot));      
      %dist = %player.club;
      %increments = %dist / $puttspeed;
      %xOffset = $puttspeed * cos(%angle + 90);
      %yOffset = $puttspeed * sin(%angle + 90);
      putt(%player, %xOffset, %yOffset, %increments);
   }
   else
   {
      %vehicleId = playerManager::playerNumToVehicleId(%player);
      %angle = radToDeg(getPosition(%vehicleId, rot));
      %dist = %player.club;
      %increments = %dist / $drivespeed;
      %xOffset = $drivespeed * cos(%angle + 90);
      %yOffset = $drivespeed * sin(%angle + 90);
      //Wind Factor
      if($winddir == "N")
      {
         %yOffset = %yOffset + ($windspeed / 8);
      }
      else if($winddir == "S")
      {
         %yOffset = %yOffset - ($windspeed / 8);
      }      
      else if($winddir == "E")
      {         
         %xOffset = %xOffset + ($windspeed / 8);
      }
      else if($winddir == "W")
      {
         %xOffset = %xOffset - ($windspeed / 8);
      }
      %height = %dist / 3;
      %zOffset = 3 * (%height / %increments);
      %initHeight = getPosition(%player.ball, z) - 6;
      %finalHeight = %initHeight + %height;
      %dir = 0;
      %inc = %increments / 3;
      fly(%player, %xOffset, %yOffset, %zOffset, %finalHeight, %dir, %dist, %inc);
   }
}

function fly(%player, %xOffset, %yOffset, %zOffset, %finalHeight, %dir, %dist, %inc)
{
   %x = getPosition(%player.ball, x) + %xOffset;
   %y = getPosition(%player.ball, y) + %yOffset;
   %z = getPosition(%player.ball, z);
   %xFut = getPosition(%player.ball, x) + (%xOffset * 2);
   %yFut = getPosition(%player.ball, y) + (%yOffset * 2);
   if((%z < %finalHeight)&&(%dir == 0))
   {
      %lock = false;
      %z = getPosition(%player.ball, z) + %zOffset;
      %zFut = getPosition(%player.ball, z) + (%zOffset * 2);
   }
   else
   {
      %dir = 1;
      if((%dir == 1)&&(%inc > 0))
      {
         %inc--;
         %z = getPosition(%player.ball, z);
         %zFut = getPosition(%player.ball, z);
      }
      else
      {
         %z = getPosition(%player.ball, z) - %zOffset;
         %zFut = getPosition(%player.ball, z)- (%zOffset * 2);
      }
   }
   setPosition(%player.ball, %x, %y, %z);
   if(%zFut > (getTerrainHeight(%xFut, %yFut) - 6))
   {
      schedule("fly(" @ %player @ ", " @ %xOffset @ ", " @ %yOffset @ ", " @ %zOffset @ ", " @ %finalHeight @ ", " @ %dir @ ", " @ %dist @ ", " @ %inc @ ");", 0.1);
   }
   else
   {
      %rolldist = %dist * 0.05;
      %rollInc = floor(%rolldist / $puttspeed);
      schedule("roll(" @ %player @ ", " @ %xOffset @ ", " @ %yOffset @ ", " @ %rollInc @ ");", 0.1);
   }
}

function roll(%player, %xOffset, %yOffset, %rollInc)
{
   if(%rollInc > 0)
   {
      %rollInc--;
      %x = getPosition(%player.ball, x) + %xOffset;
      %y = getPosition(%player.ball, y) + %yOffset;
      %z = getTerrainHeight(%x, %y) - 6;
      setPosition(%player.ball, %x, %y, %z);
      schedule("roll(" @ %player @ ", " @ %xOffset @ ", " @ %yOffset @ ", " @ %rollInc @ ");", 0.1);
   }
   else
   {
      %x1 = getPosition(%player.ball, x);
      %y1 = getPosition(%player.ball, y);
      %smallestDist = 9999999999;
      for(%i = 0; %i <= 18; %i++)
      {
         %x2 = getPosition($flag[%i], x);
         %y2 = getPosition($flag[%i], y);
         %xDist = abs(%x2 - %x1);
         %yDist = abs(%y2 - %y1);
         %distToFlag = getHypotenuse(%xDist, %yDist);
         if(%distToFlag < %smallestDist)
         {
            %smallestDist = %distToFlag;
            %nearestFlag = $flag[%i];
            %course = %i;
         }
      }
      if(%smallestDist <= 10)
      {
         if(%course == 0)
         {
            if(%player.strokes == 1)
            {
               say("Everybody", 5, getName(%player) @ " made a hole-in-one on the practice hole!");
            }
            else
            {
               say("Everybody", 5, getName(%player) @ " completed the practice hole in " @ %player.strokes @ " strokes!");
            }
         }
         else if((%course > 0)&&(%course <= 10))
         {
            if(%course == 7)
            {
               %num = 125;
            }
            else if(%course == 8)
            {
               %num = 50;
            }
            else
            {
               %num = 100;
            }
            %player.points = %player.points + round(%num / %player.strokes);
            if(%player.strokes == 1)
            {
               say("Everybody", 5, getName(%player) @ " made a hole-in-one on course #" @ %course @ "!");
            }
            else
            {
               say("Everybody", 5, getName(%player) @ " completed course #" @ %course @ " in " @ %player.strokes @ " strokes!");
            }
         }
         else if(%course > 10)
         {
            %nav11 = "Alpha";
            %nav12 = "Bravo";
            %nav13 = "Charlie";
            %nav14 = "Delta";
            %nav15 = "Echo";
            %nav16 = "Foxtrot";
            %nav17 = "Kilo";
            %nav18 = "Omega";
            %nav = %nav[%course];
            if(%course == 11)
            {
               %num = 100;
            }
            else if(%course == 12)
            {
               %num = 150;
            }
            else
            {
               %num = 200;
            }
            %player.points = %player.points + round(%num / %player.strokes);
            if(%player.strokes == 1)
            {
               say("Everybody", 5, getName(%player) @ " made a hole-in-one on course #" @ %course @ "! (nav " @ %nav @ ")");
            }
            else
            {
               say("Everybody", 5, getName(%player) @ " completed course #" @ %course @ " (nav " @ %nav @ ") in " @ %player.strokes @ " strokes!");
            } 
         }
         setShapeVisibility(%player.ball, false);
         %vehicleId = playerManager::playerNumToVehicleId(%player);
         schedule("reDrop(" @ %vehicleId @ ");", 3);
         schedule("teeOff(" @ %vehicleId @ ");", 3.1);
      }
      %player.lock = false;
   }
}

function putt(%player, %xOffset, %yOffset, %increments)
{
   if(%increments > 0)
   {
      %increments--;
      %x = getPosition(%player.ball, x) + %xOffset;
      %y = getPosition(%player.ball, y) + %yOffset;
      %z = getTerrainHeight(%x, %y) - 6;
      setPosition(%player.ball, %x, %y, %z);
      schedule("putt(" @ %player @ ", " @ %xOffset @ ", " @ %yOffset @ ", " @ %increments @ ");", 0.1);
   }
   else
   {
      %x1 = getPosition(%player.ball, x);
      %y1 = getPosition(%player.ball, y);
      %smallestDist = 9999999999;
      for(%i = 0; %i <= 18; %i++)
      {         
         %x2 = getPosition($flag[%i], x);
         %y2 = getPosition($flag[%i], y);
         %xDist = abs(%x2 - %x1);
         %yDist = abs(%y2 - %y1);
         %distToFlag = getHypotenuse(%xDist, %yDist);
         if(%distToFlag < %smallestDist)
         {
            %smallestDist = %distToFlag;
            %nearestFlag = $flag[%i];
            %course = %i;
         }
      }
      if(%smallestDist <= 10)
      {
         if(%course == 0)
         {
            if(%player.strokes == 1)
            {
               say("Everybody", 5, getName(%player) @ " made a hole-in-one on the practice hole!");
            }
            else
            {
               say("Everybody", 5, getName(%player) @ " completed the practice hole in " @ %player.strokes @ " strokes!");
            }
         }
         else if((%course > 0)&&(%course <= 10))
         {            
            if(%course == 7)
            {
               %num = 125;
            }
            else if(%course == 8)
            {
               %num = 50;
            }
            else
            {
               %num = 100;
            }
            %player.points = %player.points + round(%num / %player.strokes);
            if(%player.strokes == 1)
            {
               say("Everybody", 5, getName(%player) @ " made a hole-in-one on course #" @ %course @ "!");
            }
            else
            {
               say("Everybody", 5, getName(%player) @ " completed course #" @ %course @ " in " @ %player.strokes @ " strokes!");
            }
         }
         else if(%course > 10)
         {
            %nav11 = "Alpha";
            %nav12 = "Bravo";
            %nav13 = "Charlie";
            %nav14 = "Delta";
            %nav15 = "Echo";
            %nav16 = "Foxtrot";
            %nav17 = "Kilo";
            %nav18 = "Omega";
            %nav = %nav[%course];
            if(%course == 11)
            {
               %num = 100;
            }
            else if(%course == 12)
            {
               %num = 150;
            }
            else
            {
               %num = 200;
            }
            %player.points = %player.points + round(%num / %player.strokes);
            if(%player.strokes == 1)
            {
               say("Everybody", 5, getName(%player) @ " made a hole-in-one on course #" @ %course @ "! (nav " @ %nav @ ")");
            }
            else
            {
               say("Everybody", 5, getName(%player) @ " completed course #" @ %course @ " (nav " @ %nav @ ") in " @ %player.strokes @ " strokes!");
            } 
         }         
         setShapeVisibility(%player.ball, false);
         %vehicleId = playerManager::playerNumToVehicleId(%player);
         schedule("reDrop(" @ %vehicleId @ ");", 3);
         schedule("teeOff(" @ %vehicleId @ ");", 3.1);
      }
      %player.lock = false;
   }
}

function changeWind()
{
   $windspeed = randomInt(0,10);
   %random = randomInt(0,3);
   if(%random == 0)
   {
      $winddir = "N";
   }
   else if(%random == 1)
   {
      $winddir = "S";
   }
   else if(%random == 2)
   {
      $winddir = "E";
   }
   else if(%random == 3)
   {
      $winddir = "W";
   }
   say("Everybody", 7, "<F4>Wind: " @ $windspeed @ " mph " @ $winddir);
   %time = randomInt(30, 120);
   schedule("changeWind();", %time);
}

function vehicle::onDestroyed(%destroyed, %destroyer)
{
   %player = playerManager::vehicleIdToPlayerNum(%destroyed);
   %ball = %player.ball;
   schedule("deleteObject(" @ %ball @ ");", 3);
   %randomMsg = randomInt(0,2);
   if(%randomMsg == 0)
   {
      say("Everybody", 0, getName(%player) @ " went back to the wait room to polish his golf clubs."); 
   }
   else if(%randomMsg == 1)
   {
      say("Everybody", 0, getName(%player) @ " decided to go and buy some better golf clubs."); 
   }
   else if(%randomMsg == 2)
   {
      say("Everybody", 0, getName(%player) @ " lost his golf ball and went back to the wait room to get a new one."); 
   }

   // left over from missionStdLib.cs
   vehicle::onDestroyedLog(%destroyed, %destroyer);
   
   // enforce the rules
   if($server::TeamPlay == true)
   {
      if((getTeam(%destroyed) == getTeam(%destroyer))&&(%destroyed != %destroyer))
      {
         antiTeamKill(%destroyer);
      }
   }   
}

function onMissionEnd()
{
   flushConsoleScheduler();
   %count = playerManager::getPlayerCount();
   for(%i = 0; %i < %count; %i++)
   {
      %player = playerManager::getPlayerNum(%i);
      deleteObject(%player.ball);
   }
}

function getPlayerScore(%player)
{
   return %player.points;
}

function getCurrentStrokes(%player)
{
   return %player.strokes;
}

function getTotalStrokes(%player)
{
   return %player.totalStrokes;
}

function getWind()
{
   return $windspeed @ " mph " @ $winddir;
}

function initScoreBoard()
{
   deleteVariables("$ScoreBoard::PlayerColumn*");
   deleteVariables("$ScoreBoard::TeamColumn*");

   if($server::TeamPlay == "True")	
   {
	   // Player ScoreBoard column headings
	   $ScoreBoard::PlayerColumnHeader1 = "Squad";
	   $ScoreBoard::PlayerColumnHeader2 = "Score";
	   $ScoreBoard::PlayerColumnHeader3 = "Current Strokes";
	   $ScoreBoard::PlayerColumnHeader4 = "Total Strokes";

	   // Player ScoreBoard column functions
	   $ScoreBoard::PlayerColumnFunction1 = "getSquad";
	   $ScoreBoard::PlayerColumnFunction2 = "getPlayerScore";
	   $ScoreBoard::PlayerColumnFunction3 = "getCurrentStrokes";
	   $ScoreBoard::PlayerColumnFunction4 = "getTotalStrokes";
   }
   else
   {
       // Player ScoreBoard column headings
	   $ScoreBoard::PlayerColumnHeader1 = "Squad";
	   $ScoreBoard::PlayerColumnHeader2 = "Score";
	   $ScoreBoard::PlayerColumnHeader3 = "Current Strokes";
	   $ScoreBoard::PlayerColumnHeader4 = "Total Strokes";

	   // Player ScoreBoard column functions
	   $ScoreBoard::PlayerColumnFunction1 = "getSquad";
	   $ScoreBoard::PlayerColumnFunction2 = "getPlayerScore";
	   $ScoreBoard::PlayerColumnFunction3 = "getCurrentStrokes";
	   $ScoreBoard::PlayerColumnFunction4 = "getTotalStrokes";
   }

   // Team ScoreBoard column headings
   $ScoreBoard::TeamColumnHeader1 = "Players";
   $ScoreBoard::TeamColumnHeader2 = "Wind Conditions";

   // Team ScoreBoard column functions
   $ScoreBoard::TeamColumnFunction1 = "getNumberOfPlayersOnTeam";
   $ScoreBoard::TeamColumnFunction2 = "getWind";

   // tell server to process all the scoreboard definitions defined above
   serverInitScoreBoard();
}

function abs(%number)
{
   if(%number >= 0)
   {
      %answer = %number;
   }
   else if(%number < 0)
   {
      %answer = -%number;
   }
}

function getHypotenuse(%deltaX, %deltaY, %deltaZ)
{
   if(%deltaZ == "")
   {
      %answer = sqrt((%deltaX * %deltaX) + (%deltaY * %deltaY));
   }
   else if(%deltaZ != "")
   {
      %hyp = sqrt((%deltaX * %deltaX) + (%deltaY * %deltaY));
      %answer = sqrt((%hyp * %hyp) + (%deltaZ * %deltaZ));
   }
   return %answer;
}

function RadToDeg(%radians)
{
   %degrees = (%radians * 180) / 3.14159;
   return %degrees;
}

function round(%number)
{
   %roundNum = %number;
   if(%number > 0)
   {
      %excess = (%number - floor(%number));
      if(%excess >= 0.5)
      {
         %roundNum = (floor(%number) + 1);
      }
      else
      {
         %roundNum = floor(%number);
      }
   }
   if(%number < 0)
   {
      %excess = (floor(%number) - %number);
      if(%excess <= 0.5)
      {
         %roundNum = floor(%number);
      }
      else
      {
         %roundNum = (floor(%number) - 1);
      }
   }
   return %roundNum;
}

function adjustAngle(%angle)
{
   if(%angle >= 360)
   {
      while(%angle >= 360)
      {
         %angle = (%angle - 360);
      }
   }
   else if(%angle < 0)
   {
      while(%angle < 0)
      {
         %angle = (%angle + 360);
      }
   }
   return %angle;
}

function sin(%angle)
{
   %angle = round(adjustAngle(%angle));
   return $sin[%angle];
}

function cos(%angle)
{
   %angle = round(adjustAngle(%angle));
   return $cos[%angle];
} 

$sin0 = 0;
$sin1 = 0.017452;
$sin2 = 0.034899;
$sin3 = 0.052335;
$sin4 = 0.069756;
$sin5 = 0.087156;
$sin6 = 0.104528;
$sin7 = 0.121869;
$sin8 = 0.139173;
$sin9 = 0.156434;
$sin10 = 0.173648;
$sin11 = 0.190809;
$sin12 = 0.207912;
$sin13 = 0.224951;
$sin14 = 0.241922;
$sin15 = 0.258819;
$sin16 = 0.275637;
$sin17 = 0.292372;
$sin18 = 0.309017;
$sin19 = 0.325568;
$sin20 = 0.342020;
$sin21 = 0.358368;
$sin22 = 0.374607;
$sin23 = 0.390731;
$sin24 = 0.406737;
$sin25 = 0.422618;
$sin26 = 0.438371;
$sin27 = 0.453990;
$sin28 = 0.469472;
$sin29 = 0.484810;
$sin30 = 0.5;
$sin31 = 0.515038;
$sin32 = 0.529919;
$sin33 = 0.544639;
$sin34 = 0.559193;
$sin35 = 0.573576;
$sin36 = 0.587785;
$sin37 = 0.601815;
$sin38 = 0.615661;
$sin39 = 0.629320;
$sin40 = 0.642788;
$sin41 = 0.656059;
$sin42 = 0.669131;
$sin43 = 0.681998;
$sin44 = 0.694658;
$sin45 = 0.707107;
$sin46 = 0.719340;
$sin47 = 0.731354;
$sin48 = 0.743145;
$sin49 = 0.754710;
$sin50 = 0.766044;
$sin51 = 0.777146;
$sin52 = 0.788011;
$sin53 = 0.798636;
$sin54 = 0.809017;
$sin55 = 0.819152;
$sin56 = 0.829038;
$sin57 = 0.838671;
$sin58 = 0.848048;
$sin59 = 0.857167;
$sin60 = 0.866025;
$sin61 = 0.874620;
$sin62 = 0.882948;
$sin63 = 0.891007;
$sin64 = 0.898794;
$sin65 = 0.906308;
$sin66 = 0.913545;
$sin67 = 0.920505;
$sin68 = 0.927184;
$sin69 = 0.933580;
$sin70 = 0.939693;
$sin71 = 0.945519;
$sin72 = 0.951057;
$sin73 = 0.956305;
$sin74 = 0.961262;
$sin75 = 0.965926;
$sin76 = 0.970296;
$sin77 = 0.974370;
$sin78 = 0.978148;
$sin79 = 0.981627;
$sin80 = 0.984808;
$sin81 = 0.987688;
$sin82 = 0.990268;
$sin83 = 0.992546;
$sin84 = 0.994522;
$sin85 = 0.996195;
$sin86 = 0.997564;
$sin87 = 0.998630;
$sin88 = 0.999391;
$sin89 = 0.999848;
$sin90 = 1;
$sin91 = 0.999848;
$sin92 = 0.999391;
$sin93 = 0.998630;
$sin94 = 0.997564;
$sin95 = 0.996195;
$sin96 = 0.994522;
$sin97 = 0.992546;
$sin98 = 0.990268;
$sin99 = 0.987688;
$sin100 = 0.984808;
$sin101 = 0.981627;
$sin102 = 0.978148;
$sin103 = 0.974370;
$sin104 = 0.970296;
$sin105 = 0.965926;
$sin106 = 0.961262;
$sin107 = 0.956305;
$sin108 = 0.951057;
$sin109 = 0.945519;
$sin110 = 0.939693;
$sin111 = 0.933580;
$sin112 = 0.927184;
$sin113 = 0.920505;
$sin114 = 0.913545;
$sin115 = 0.906308;
$sin116 = 0.898794;
$sin117 = 0.891007;
$sin118 = 0.882948;
$sin119 = 0.874620;
$sin120 = 0.866025;
$sin121 = 0.857167;
$sin122 = 0.848048;
$sin123 = 0.838671;
$sin124 = 0.829038;
$sin125 = 0.819152;
$sin126 = 0.809017;
$sin127 = 0.798636;
$sin128 = 0.788011;
$sin129 = 0.777146;
$sin130 = 0.766044;
$sin131 = 0.754710;
$sin132 = 0.743145;
$sin133 = 0.731354;
$sin134 = 0.719340;
$sin135 = 0.707107;
$sin136 = 0.694658;
$sin137 = 0.681998;
$sin138 = 0.669131;
$sin139 = 0.656059;
$sin140 = 0.642788;
$sin141 = 0.629320;
$sin142 = 0.615661;
$sin143 = 0.601815;
$sin144 = 0.587785;
$sin145 = 0.573576;
$sin146 = 0.559193;
$sin147 = 0.544639;
$sin148 = 0.529919;
$sin149 = 0.515038;
$sin150 = 0.5;
$sin151 = 0.484810;
$sin152 = 0.469472;
$sin153 = 0.453990;
$sin154 = 0.438371;
$sin155 = 0.422618;
$sin156 = 0.406737;
$sin157 = 0.390731;
$sin158 = 0.374607;
$sin159 = 0.358368;
$sin160 = 0.342020;
$sin161 = 0.325568;
$sin162 = 0.309017;
$sin163 = 0.292372;
$sin164 = 0.275637;
$sin165 = 0.258819;
$sin166 = 0.241922;
$sin167 = 0.224951;
$sin168 = 0.207912;
$sin169 = 0.190809;
$sin170 = 0.173648;
$sin171 = 0.156434;
$sin172 = 0.139173;
$sin173 = 0.121869;
$sin174 = 0.104528;
$sin175 = 0.087156;
$sin176 = 0.069756;
$sin177 = 0.052335;
$sin178 = 0.034899;
$sin179 = 0.017452;
$sin180 = 0;
$sin181 = -0.017452;
$sin182 = -0.034899;
$sin183 = -0.052335;
$sin184 = -0.069756;
$sin185 = -0.087156;
$sin186 = -0.104528;
$sin187 = -0.121869;
$sin188 = -0.139173;
$sin189 = -0.156434;
$sin190 = -0.173648;
$sin191 = -0.190809;
$sin192 = -0.207912;
$sin193 = -0.224951;
$sin194 = -0.241922;
$sin195 = -0.258819;
$sin196 = -0.275637;
$sin197 = -0.292372;
$sin198 = -0.309017;
$sin199 = -0.325568;
$sin200 = -0.342020;
$sin201 = -0.358368;
$sin202 = -0.374607;
$sin203 = -0.390731;
$sin204 = -0.406737;
$sin205 = -0.422618;
$sin206 = -0.438371;
$sin207 = -0.453990;
$sin208 = -0.469472;
$sin209 = -0.484810;
$sin210 = -0.5;
$sin211 = -0.515038;
$sin212 = -0.529919;
$sin213 = -0.544639;
$sin214 = -0.559193;
$sin215 = -0.573576;
$sin216 = -0.587785;
$sin217 = -0.601815;
$sin218 = -0.615661;
$sin219 = -0.629320;
$sin220 = -0.642788;
$sin221 = -0.656059;
$sin222 = -0.669131;
$sin223 = -0.681998;
$sin224 = -0.694658;
$sin225 = -0.707107;
$sin226 = -0.719340;
$sin227 = -0.731354;
$sin228 = -0.743145;
$sin229 = -0.754710;
$sin230 = -0.766044;
$sin231 = -0.777146;
$sin232 = -0.788011;
$sin233 = -0.798636;
$sin234 = -0.809017;
$sin235 = -0.819152;
$sin236 = -0.829038;
$sin237 = -0.838671;
$sin238 = -0.848048;
$sin239 = -0.857167;
$sin240 = -0.866025;
$sin241 = -0.874620;
$sin242 = -0.882948;
$sin243 = -0.891007;
$sin244 = -0.898794;
$sin245 = -0.906308;
$sin246 = -0.913545;
$sin247 = -0.920505;
$sin248 = -0.927184;
$sin249 = -0.933580;
$sin250 = -0.939693;
$sin251 = -0.945519;
$sin252 = -0.951057;
$sin253 = -0.956305;
$sin254 = -0.961262;
$sin255 = -0.965926;
$sin256 = -0.970296;
$sin257 = -0.974370;
$sin258 = -0.978148;
$sin259 = -0.981627;
$sin260 = -0.984808;
$sin261 = -0.987688;
$sin262 = -0.990268;
$sin263 = -0.992546;
$sin264 = -0.994522;
$sin265 = -0.996195;
$sin266 = -0.997564;
$sin267 = -0.998630;
$sin268 = -0.999391;
$sin269 = -0.999848;
$sin270 = -1;
$sin271 = -0.999848;
$sin272 = -0.999391;
$sin273 = -0.998630;
$sin274 = -0.997564;
$sin275 = -0.996195;
$sin276 = -0.994522;
$sin277 = -0.992546;
$sin278 = -0.990268;
$sin279 = -0.987688;
$sin280 = -0.984808;
$sin281 = -0.981627;
$sin282 = -0.978148;
$sin283 = -0.974370;
$sin284 = -0.970296;
$sin285 = -0.965926;
$sin286 = -0.961262;
$sin287 = -0.956305;
$sin288 = -0.951057;
$sin289 = -0.945519;
$sin290 = -0.939693;
$sin291 = -0.933580;
$sin292 = -0.927184;
$sin293 = -0.920505;
$sin294 = -0.913545;
$sin295 = -0.906308;
$sin296 = -0.898794;
$sin297 = -0.891007;
$sin298 = -0.882948;
$sin299 = -0.874620;
$sin300 = -0.866025;
$sin301 = -0.857167;
$sin302 = -0.848048;
$sin303 = -0.838671;
$sin304 = -0.829038;
$sin305 = -0.819152;
$sin306 = -0.809017;
$sin307 = -0.798636;
$sin308 = -0.788011;
$sin309 = -0.777146;
$sin310 = -0.766044;
$sin311 = -0.754710;
$sin312 = -0.743145;
$sin313 = -0.731354;
$sin314 = -0.719340;
$sin315 = -0.707107;
$sin316 = -0.694658;
$sin317 = -0.681998;
$sin318 = -0.669131;
$sin319 = -0.656059;
$sin320 = -0.642788;
$sin321 = -0.629320;
$sin322 = -0.615661;
$sin323 = -0.601815;
$sin324 = -0.587785;
$sin325 = -0.573576;
$sin326 = -0.559193;
$sin327 = -0.544639;
$sin328 = -0.529919;
$sin329 = -0.515038;
$sin330 = -0.5;
$sin331 = -0.484810;
$sin332 = -0.469472;
$sin333 = -0.453990;
$sin334 = -0.438371;
$sin335 = -0.422618;
$sin336 = -0.406737;
$sin337 = -0.390731;
$sin338 = -0.374607;
$sin339 = -0.358368;
$sin340 = -0.342020;
$sin341 = -0.325568;
$sin342 = -0.309017;
$sin343 = -0.292372;
$sin344 = -0.275637;
$sin345 = -0.258819;
$sin346 = -0.241922;
$sin347 = -0.224951;
$sin348 = -0.207912;
$sin349 = -0.190809;
$sin350 = -0.173648;
$sin351 = -0.156434;
$sin352 = -0.139173;
$sin353 = -0.121869;
$sin354 = -0.104528;
$sin355 = -0.087156;
$sin356 = -0.069756;
$sin357 = -0.052335;
$sin358 = -0.034899;
$sin359 = -0.017452;
$sin360 = 0;

$cos0 = 1;
$cos1 = 0.999848;
$cos2 = 0.999391;
$cos3 = 0.998630;
$cos4 = 0.997564;
$cos5 = 0.996195;
$cos6 = 0.994522;
$cos7 = 0.992546;
$cos8 = 0.990268;
$cos9 = 0.987688;
$cos10 = 0.984808;
$cos11 = 0.981627;
$cos12 = 0.978148;
$cos13 = 0.974370;
$cos14 = 0.970296;
$cos15 = 0.965926;
$cos16 = 0.961262;
$cos17 = 0.956305;
$cos18 = 0.951057;
$cos19 = 0.945519;
$cos20 = 0.939693;
$cos21 = 0.933580;
$cos22 = 0.927184;
$cos23 = 0.920505;
$cos24 = 0.913545;
$cos25 = 0.906308;
$cos26 = 0.898794;
$cos27 = 0.891007;
$cos28 = 0.882948;
$cos29 = 0.874620;
$cos30 = 0.866025;
$cos31 = 0.857167;
$cos32 = 0.848048;
$cos33 = 0.838671;
$cos34 = 0.829038;
$cos35 = 0.819152;
$cos36 = 0.809017;
$cos37 = 0.798636;
$cos38 = 0.788011;
$cos39 = 0.777146;
$cos40 = 0.766044;
$cos41 = 0.754710;
$cos42 = 0.743145;
$cos43 = 0.731354;
$cos44 = 0.719340;
$cos45 = 0.707107;
$cos46 = 0.694658;
$cos47 = 0.681998;
$cos48 = 0.669131;
$cos49 = 0.656059;
$cos50 = 0.642788;
$cos51 = 0.629320;
$cos52 = 0.615661;
$cos53 = 0.601815;
$cos54 = 0.587785;
$cos55 = 0.573576;
$cos56 = 0.559193;
$cos57 = 0.544639;
$cos58 = 0.529919;
$cos59 = 0.515038;
$cos60 = 0.5;
$cos61 = 0.484810;
$cos62 = 0.469472;
$cos63 = 0.453990;
$cos64 = 0.438371;
$cos65 = 0.422618;
$cos66 = 0.406737;
$cos67 = 0.390731;
$cos68 = 0.374607;
$cos69 = 0.358368;
$cos70 = 0.342020;
$cos71 = 0.325568;
$cos72 = 0.309017;
$cos73 = 0.292372;
$cos74 = 0.275637;
$cos75 = 0.258819;
$cos76 = 0.241922;
$cos77 = 0.224951;
$cos78 = 0.207912;
$cos79 = 0.190809;
$cos80 = 0.173648;
$cos81 = 0.156434;
$cos82 = 0.139173;
$cos83 = 0.121869;
$cos84 = 0.104528;
$cos85 = 0.087156;
$cos86 = 0.069756;
$cos87 = 0.052336;
$cos88 = 0.034899;
$cos89 = 0.017452;
$cos90 = 0;
$cos91 = -0.017452;
$cos92 = -0.034899;
$cos93 = -0.052336;
$cos94 = -0.069756;
$cos95 = -0.087156;
$cos96 = -0.104528;
$cos97 = -0.121869;
$cos98 = -0.139173;
$cos99 = -0.156434;
$cos100 = -0.173648;
$cos101 = -0.190809;
$cos102 = -0.207912;
$cos103 = -0.224951;
$cos104 = -0.241922;
$cos105 = -0.258819;
$cos106 = -0.275637;
$cos107 = -0.292372;
$cos108 = -0.309017;
$cos109 = -0.325568;
$cos110 = -0.342020;
$cos111 = -0.358368;
$cos112 = -0.374607;
$cos113 = -0.390731;
$cos114 = -0.406737;
$cos115 = -0.422618;
$cos116 = -0.438371;
$cos117 = -0.453990;
$cos118 = -0.469472;
$cos119 = -0.484810;
$cos120 = -0.5;
$cos121 = -0.515038;
$cos122 = -0.529919;
$cos123 = -0.544639;
$cos124 = -0.559193;
$cos125 = -0.573576;
$cos126 = -0.587785;
$cos127 = -0.601815;
$cos128 = -0.615661;
$cos129 = -0.629320;
$cos130 = -0.642788;
$cos131 = -0.656059;
$cos132 = -0.669131;
$cos133 = -0.681998;
$cos134 = -0.694658;
$cos135 = -0.707107;
$cos136 = -0.719340;
$cos137 = -0.731354;
$cos138 = -0.743145;
$cos139 = -0.754710;
$cos140 = -0.766044;
$cos141 = -0.777146;
$cos142 = -0.788011;
$cos143 = -0.798636;
$cos144 = -0.809017;
$cos145 = -0.819152;
$cos146 = -0.829038;
$cos147 = -0.838671;
$cos148 = -0.848048;
$cos149 = -0.857167;
$cos150 = -0.866025;
$cos151 = -0.874620;
$cos152 = -0.882948;
$cos153 = -0.891007;
$cos154 = -0.898794;
$cos155 = -0.906308;
$cos156 = -0.913545;
$cos157 = -0.920505;
$cos158 = -0.927184;
$cos159 = -0.933580;
$cos160 = -0.939693;
$cos161 = -0.945519;
$cos162 = -0.951057;
$cos163 = -0.956305;
$cos164 = -0.961262;
$cos165 = -0.965926;
$cos166 = -0.970296;
$cos167 = -0.974370;
$cos168 = -0.978148;
$cos169 = -0.981627;
$cos170 = -0.984808;
$cos171 = -0.987688;
$cos172 = -0.990268;
$cos173 = -0.992546;
$cos174 = -0.994522;
$cos175 = -0.996195;
$cos176 = -0.997564;
$cos177 = -0.998630;
$cos178 = -0.999391;
$cos179 = -0.999848;
$cos180 = -1;
$cos181 = -0.999848;
$cos182 = -0.999391;
$cos183 = -0.998630;
$cos184 = -0.997564;
$cos185 = -0.996195;
$cos186 = -0.994522;
$cos187 = -0.992546;
$cos188 = -0.990268;
$cos189 = -0.987688;
$cos190 = -0.984808;
$cos191 = -0.981627;
$cos192 = -0.978148;
$cos193 = -0.974370;
$cos194 = -0.970296;
$cos195 = -0.965926;
$cos196 = -0.961262;
$cos197 = -0.956305;
$cos198 = -0.951057;
$cos199 = -0.945519;
$cos200 = -0.939693;
$cos201 = -0.933580;
$cos202 = -0.927184;
$cos203 = -0.920505;
$cos204 = -0.913545;
$cos205 = -0.906308;
$cos206 = -0.898794;
$cos207 = -0.891007;
$cos208 = -0.882948;
$cos209 = -0.874620;
$cos210 = -0.866025;
$cos211 = -0.857167;
$cos212 = -0.848048;
$cos213 = -0.838671;
$cos214 = -0.829038;
$cos215 = -0.819152;
$cos216 = -0.809017;
$cos217 = -0.798636;
$cos218 = -0.788011;
$cos219 = -0.777146;
$cos220 = -0.766044;
$cos221 = -0.754710;
$cos222 = -0.743145;
$cos223 = -0.731354;
$cos224 = -0.719340;
$cos225 = -0.707107;
$cos226 = -0.694658;
$cos227 = -0.681998;
$cos228 = -0.669131;
$cos229 = -0.656059;
$cos230 = -0.642788;
$cos231 = -0.629320;
$cos232 = -0.615661;
$cos233 = -0.601815;
$cos234 = -0.587785;
$cos235 = -0.573576;
$cos236 = -0.559193;
$cos237 = -0.544639;
$cos238 = -0.529919;
$cos239 = -0.515038;
$cos240 = -0.5;
$cos241 = -0.484810;
$cos242 = -0.469472;
$cos243 = -0.453990;
$cos244 = -0.438371;
$cos245 = -0.422618;
$cos246 = -0.406737;
$cos247 = -0.390731;
$cos248 = -0.374607;
$cos249 = -0.358368;
$cos250 = -0.342020;
$cos251 = -0.325568;
$cos252 = -0.309017;
$cos253 = -0.292372;
$cos254 = -0.275637;
$cos255 = -0.258819;
$cos256 = -0.241922;
$cos257 = -0.224951;
$cos258 = -0.207912;
$cos259 = -0.190809;
$cos260 = -0.173648;
$cos261 = -0.156434;
$cos262 = -0.139173;
$cos263 = -0.121869;
$cos264 = -0.104528;
$cos265 = -0.087156;
$cos266 = -0.069756;
$cos267 = -0.052336;
$cos268 = -0.034899;
$cos269 = -0.017452;
$cos270 = 0;
$cos271 = 0.017452;
$cos272 = 0.034899;
$cos273 = 0.052336;
$cos274 = 0.069756;
$cos275 = 0.087156;
$cos276 = 0.104528;
$cos277 = 0.121869;
$cos278 = 0.139173;
$cos279 = 0.156434;
$cos280 = 0.173648;
$cos281 = 0.190809;
$cos282 = 0.207912;
$cos283 = 0.224951;
$cos284 = 0.241922;
$cos285 = 0.258819;
$cos286 = 0.275637;
$cos287 = 0.292372;
$cos288 = 0.309017;
$cos289 = 0.325568;
$cos290 = 0.342020;
$cos291 = 0.358368;
$cos292 = 0.374607;
$cos293 = 0.390731;
$cos294 = 0.406737;
$cos295 = 0.422618;
$cos296 = 0.438371;
$cos297 = 0.453990;
$cos298 = 0.469472;
$cos299 = 0.484810;
$cos300 = 0.5;
$cos301 = 0.515038;
$cos302 = 0.529919;
$cos303 = 0.544639;
$cos304 = 0.559193;
$cos305 = 0.573576;
$cos306 = 0.587785;
$cos307 = 0.601815;
$cos308 = 0.615661;
$cos309 = 0.629320;
$cos310 = 0.642788;
$cos311 = 0.656059;
$cos312 = 0.669131;
$cos313 = 0.681998;
$cos314 = 0.694658;
$cos315 = 0.707107;
$cos316 = 0.719340;
$cos317 = 0.731354;
$cos318 = 0.743145;
$cos319 = 0.754710;
$cos320 = 0.766044;
$cos321 = 0.777146;
$cos322 = 0.788011;
$cos323 = 0.798636;
$cos324 = 0.809017;
$cos325 = 0.819152;
$cos326 = 0.829038;
$cos327 = 0.838671;
$cos328 = 0.848048;
$cos329 = 0.857167;
$cos330 = 0.866025;
$cos331 = 0.874620;
$cos332 = 0.882948;
$cos333 = 0.891007;
$cos334 = 0.898794;
$cos335 = 0.906308;
$cos336 = 0.913545;
$cos337 = 0.920505;
$cos338 = 0.927184;
$cos339 = 0.933580;
$cos340 = 0.939693;
$cos341 = 0.945519;
$cos342 = 0.951057;
$cos343 = 0.956305;
$cos344 = 0.961262;
$cos345 = 0.965926;
$cos346 = 0.970296;
$cos347 = 0.974370;
$cos348 = 0.978148;
$cos349 = 0.981627;
$cos350 = 0.984808;
$cos351 = 0.987688;
$cos352 = 0.990268;
$cos353 = 0.992546;
$cos354 = 0.994522;
$cos355 = 0.996195;
$cos356 = 0.997564;
$cos357 = 0.998630;
$cos358 = 0.999391;
$cos359 = 0.999848;
$cos360 = 1;