// FILENAME:	CTF_Mirage.cs
//
// AUTHOR:		Gen. Raven [M.I.B.]
//
// Thanks to PyG for telling me I should make something like this.
// Unless of course everyone hates the map...then it's all PyG's fault!
//------------------------------------------------------------------------------
// Stealth Detection - Set to true & players with a "/" in front of their
// will be detected when they join or leave the server.

// Defaulted off since im *hoping* ancients will run this and they already 
// have stealth detect onAdd.
$stealthDetectOnAdd = false;
$stealthDetectOnRemove = true;  //Ancients has none when a player leaves

//------------------------------------------------------------------------------
$missionName = "CTF_Mirage";

$numberOfFlags = 30;           //CANT CHANGE! Number of mirage flags to choose from

//Not gonna use this junk anymore
//$akCTFRules = true;     //AutoHeal after kill or cap, fast/no shutdown pads

$maxFlagCount  = 8;           // no of flags required by a team to end the game
$flagValue     = 5;          // points your team gets for capturing
$carrierValue  = 2;          //  "      "    "    "    " killing carrier
$killPoints    = 1;
$deathPoints   = 1;
$flagTime = 180;

exec("multiplayerStdLib.cs");
exec("CTFstdLib.cs");

function setDefaultMissionOptions()
{
	$server::TeamPlay = true;
	$server::AllowDeathmatch = false;
	$server::AllowTeamPlay = true;	

   // what can the client choose for a team
	$server::AllowTeamRed = false;
	$server::AllowTeamBlue = true;
	$server::AllowTeamYellow = false;
	$server::AllowTeamPurple = true;

   // what can the server admin choose for available teams
   $server::disableTeamRed = true;
   $server::disableTeamBlue = false;
   $server::disableTeamYellow = true;
   $server::disableTeamPurple = false;
}

function onMissionStart()
{
	temperateSounds();
      initGlobalVars();
}

function onMissionLoad()
{
   cdAudioCycle("Cyberntx", "YouGot", "Terror", "Mechsoul", "NewTech"); 
   %count = playermanager::getPlayerCount();
   for(%i=0; %i<%count; %i++)
   {
      %player = playermanager::getPlayerNum(%i);
      %player.stealCount = 0;
   }
}

function player::onAdd(%player)
{
   if(($stealthDetectOnAdd == true)&&(strAlign(1, left, getname(%player))=="/"))
   {
        say(0,0,"<f4>"@getname(%player)@" joined the game","alarm2.wav");
        messagebox(%player,"This server is equipped with an anti-stealth detection system. The slash on your name has been detected. All players have been alerted to your presence.");
   }
   say(%player, 0, "Welcome to CTF Mirage! Don't be fooled by mirages, there is only one real flag at each base! You can download CTF_Mirage & other missions made by Gen. Raven [M.I.B.] on the MIB Website at www.starsiegemeninblack.cjb.net.");
  
   %player.stealCount = 0;

   //Activate Rock's Admin Pack if its being used
   RocksPlayerOnAdd(%player);
}

function player::onRemove(%player)
{
   if(($stealthDetectOnRemove == true)&&(strAlign(1, left, getname(%player))=="/"))
   {
      say(0,0,"<f4>"@getname(%player)@" left the game","alarm2.wav");
   }
}

function proximityWarning(%vehicleId, %team)
{
   %count = playermanager::getPlayerCount();
   for(%i=0;%i<%count;%i++)
   {
      %player = playermanager::getPlayerNum(%i);
      if(getTeam(%player)==%team)
      {
         say(%player,randomInt(1000,2000),"<f0>Promimity Warning: <f4>"@getVehicleName(%vehicleId));
      }
   }
}

function blueWarning::trigger::onEnter(%trigger,%vehicleId)
{
   %team = getTeam(%vehicleId);
   if(%team=="Purple Team")
   {
      proximityWarning(%vehicleid,"Blue Team");
   }
}

function purpleWarning::trigger::onEnter(%trigger,%vehicleId)
{
   %team = getTeam(%vehicleId);
   if(%team=="Blue Team")
   {
      proximityWarning(%vehicleid,"Purple Team");
   }
}

function getSteals(%player)
{
   return %player.stealCount;
}

function getSuccessRate(%player)
{
   %percent = floor(((%player.flagsCollected / %player.stealCount) * 100) + 0.5);
   if((%percent>100) || (%percent<0))
   {
      %percent = 0;
   }
   return %percent @ "%";
}

//From CTFStdLib.cs - Modified functions
//----------------------------------------------------------
// vehicle::onadd()
// vehicle::onDestroyed()
// checkFlagStolen()
// checkFlagRetrieved()
// initScoreBoard()
// more im too busy to list...
//----------------------------------------------------------
function vehicle::onAdd(%vehicleId)
{
   %player = playermanager::vehicleIdtoPlayerNum(%vehicleId);
   RocksVehicleOnAdd(%vehicleId);

   %team = getTeam(playerManager::vehicleIdToPlayerNum(%vehicleId));
   %color = teamToColor(%team);
   %flagKey = strcat(%color, "FlagCount");

   adjTeamCount(%team, 1);

   //if the flag isn't at the base, but no one has it, correct situation
   if(dataRetrieve(0, %flagKey) && !dataRetrieve(0, strcat(%color, "FlagCarried")))
   {
   	setFlag(%team, true);
   }   
}

function vehicle::onDestroyed(%destroyed,%destroyer)
{
   RocksVehicleOnDestroyed(%destroyed, %destroyer);
   %team = getTeam(%destroyed);
   adjTeamCount(%team, -1);
   %teamCount = getTeamPlayerCount(%team);      

   if(%teamCount < 1)
   {
	   setFlag(%team, false);					
   }

   %color = dataRetrieve(%destroyed, "hasFlag");
   %flagTeam = colorToTeam(%color);
   
   // if the destroyed vehicle has a flag, it goes back to it's base
   if (%color != "")
   {
      playerDropsFlag(%destroyed);
      
      // let everyone know this guy drops the flag
      %str =
         *IDMULT_CHAT_SURRENDER_FLAG_1 @
         getName( %destroyed )         @
         *IDMULT_CHAT_SURRENDER_FLAG_2 @ 
         %flagTeam                     @
         *IDMULT_CHAT_SURRENDER_FLAG_3;
      
      %soundFile = "";   
      if(%flagTeam == *IDSTR_TEAM_RED)
      {
         %soundFile = "red_flag_sur.wav";
      }
      else if(%flagTeam == *IDSTR_TEAM_BLUE)
      {
         %soundFile = "blue_flag_sur.wav";
      }
      else if(%flagTeam == *IDSTR_TEAM_YELLOW)
      {
         %soundFile = "yel_flag_sur.wav";
      }
      else
      {
         %soundFile = "purp_flag_sur.wav";
      }   
      
      say( 0, 0, %str, %soundFile );

            
      if($scoringFreeze == false)
      {     
         // destroyer's team gets credit for killing the carrier
         %destroyerTeam = getTeam(%destroyer);  
      
         // only give points if destroyed recovered his/her own flag
         if(%destroyerTeam == colorToTeam(%color))
         {
            %key = strcat(teamToColor(getTeam(%destroyer)), "CarriersKilled");
            dataStore(0, %key, 1 + dataRetrieve(0, %key));
            
            // player gets credit, too
            %player = playerManager::vehicleIdToPlayerNum(%destroyer);
            if(%player != 0)
            {
               %player.carriersKilled = %player.carriersKilled + 1;
            }
         }

         // echo the surrender to the console for logging
         echo(*IDSTR_CONSOLE_CTF_SURRENDER @ " " @ playerManager::vehicleIdToPlayerNum(%destroyed));                        
      }	  
   }
   else
   {
      // not a flag carrier ... is it an enemy?
      if($scoringFreeze == false)
      {
         if(getTeam(%destroyed) != getTeam(%destroyer))
         {
            %player = playerManager::vehicleIdToPlayerNum(%destroyer);
            if(%player != 0)
            {
               %player.genericKills = %player.genericKills + 1;
            }
         }
      }
   }
   
   // enforce the rules
   if(
      (getTeam(%destroyed) == getTeam(%destroyer)) &&
      (%destroyed != %destroyer)
   )
   {
      antiTeamKill(%destroyer);
   }

   vehicle::onDestroyedLog(%destroyed, %destroyer);
   
   // give the death messages...
   %player = playermanager::vehicleIdtoPlayerNum(%destroyed);

   %message = getFancyDeathMessage(getHUDName(%destroyed), getHUDName(%destroyer));
   if(%message != "")
   {
      say( 0, 0, %message);
   }
}

function checkFlagStolen(%team, %vehicle)
{
   %color = teamToColor(%team);
   	
   // you just hit the trigger at an enemy base, is there a flag here?
   %flagCountKey = strcat(%color, "FlagCount");
   %flagCount = dataRetrieve(0, %flagCountKey);
   
   if (%flagCount != 0 || dataRetrieve(%vehicle, "hasFlag") != "") 
   {
      return;
   }

   if (playerManager::vehicleIdToPlayerNum(%vehicle) == 0)
   { 
      return;
   }

   // stop the flag shape from rendering
   setFlag(%team, false);

   // setup the vehicle to carry the flag
   setVehicleSpecialIdentity(%vehicle, true, %color);
   dataStore(%vehicle, "hasFlag", %color);

   // increment flag count so nobody else can pickup this flag
   dataStore(0, %flagCountKey, 1);

   // set global bool for flag of that color
   dataStore(0, strcat(%color, "FlagCarried"), 1); 

   // let everyone know what happened
   %str =
         *IDMULT_CHAT_STEAL_FLAG_1 @
         getName( %vehicle ) @
         *IDMULT_CHAT_STEAL_FLAG_2 @ 
         colorToTeam(%color) @
         *IDMULT_CHAT_STEAL_FLAG_3;
   
   %soundFile = "";
   if(%team == *IDSTR_TEAM_RED)
   {
      %soundFile = "red_flag_stol.wav";
   }
   else if(%team == *IDSTR_TEAM_BLUE)
   {
      %soundFile = "blue_flag_stol.wav";
   }
   else if(%team == *IDSTR_TEAM_YELLOW)
   {
      %soundFile = "yel_flag_stol.wav";
   }
   else
   {
      %soundFile = "purp_flag_stol.wav";
   }

   say( 0, 0, %str, %soundFile );

   // echo the steal to the console for logging
   echo(*IDSTR_CONSOLE_CTF_STEAL @ " " @ playerManager::vehicleIdToPlayerNum(%vehicle));      	                     

   %player = playermanager::vehicleIdToPlayerNum(%vehicle);
   %player.stealCount++;
   
   if($flagTime != 0)
   {      
      // start a hud timer on the flag carrier
      %player = playerManager::vehicleIdToPlayerNum(%vehicle);
      
      %vehicle.timer = schedule("carrierDeath(" @ %vehicle @ ");", $flagTime);
      
      // here we should set the hudtimer
      if(%team == *IDSTR_TEAM_YELLOW)
      {
         %title = *IDMULT_CHAT_YELLOW_FLAG;
      }
      else if(%team == *IDSTR_TEAM_BLUE)
      {
         %title = *IDMULT_CHAT_BLUE_FLAG;
      }
      else if(%team == *IDSTR_TEAM_RED)
      {
         %title = *IDMULT_CHAT_RED_FLAG;
      }
      else if(%team == *IDSTR_TEAM_PURPLE)
      {
         %title = *IDMULT_CHAT_PURPLE_FLAG;
      } 
      
      setHudTimer($flagTime, -1, %title, 1, %player);      
   }
   
   // tell the vehicle where his or her base is
   %playerTeam = getTeam(%vehicle);
   
   if(%playerTeam == *IDSTR_TEAM_YELLOW)
   {
      if($yellowNavPoint != 0)
         setNavMarker($yellowNavPoint, true, %vehicle);
   } else if(%playerTeam == *IDSTR_TEAM_BLUE)
   {
      if($blueNavPoint != 0)
         setNavMarker($blueNavPoint, true, %vehicle);
   } else if(%playerTeam == *IDSTR_TEAM_RED)
   {
      if($redNavPoint != 0)
         setNavMarker($redNavPoint, true, %vehicle);
   } else if(%playerTeam == *IDSTR_TEAM_PURPLE)
   {
      if($purpleNavPoint != 0)
         setNavMarker($purpleNavPoint, true, %vehicle);
   }
}

function checkFlagRetrieved(%team, %vehicle)
{
   %color = teamToColor(%team);

   // you made it back to your own base, do you have any other teams' flags?
   if (dataRetrieve(%vehicle, "hasFlag") == "") 
      { return; }

   // is the player's team flag at his base when he brings back the enemy's flag?
   if (dataRetrieve(0, strcat(%color, "FlagCount")) != 0) 
      { return; }

   // player is no longer carrying the flag
   %hasColor = dataRetrieve(%vehicle, "hasFlag");
   %flagTeam = colorToTeam(%hasColor);
   playerDropsFlag(%vehicle);

   if($scoringFreeze == false)
   {
      // player's team gets credit for stealing the flag
      %collectedKey = strcat(teamToColor(getTeam(%vehicle)), "FlagsCollected");
      %collectedCount = dataRetrieve(0, %collectedKey);
      %collectedCount = %collectedCount + 1;
      dataStore(0, %collectedKey, %collectedCount);
      
      // player gets credit also
      %player = playerManager::vehicleIdToPlayerNum(%vehicle);
      %player.flagsCollected = %player.flagsCollected + 1;

      // echo the capture to the console for logging
      echo(*IDSTR_CONSOLE_CTF_CAPTURE @ " " @ playerManager::vehicleIdToPlayerNum(%vehicle));      	               

         healObject(%vehicle, 99999);
         healObject(%vehicle, 99999);
         healObject(%vehicle, 99999);
         healObject(%vehicle, 99999);
         healObject(%vehicle, 99999);
         reloadObject(%vehicle, 99999);

      %needMore = $maxFlagCount - %collectedCount;
      if (%needMore <= 0)
      {
         winEvent(getTeam(%vehicle));
      }
   }
  
   // let everyone know what happened
   %str =
      *IDMULT_CHAT_CAPTURE_FLAG_1 @
      getName( %vehicle ) @
      *IDMULT_CHAT_CAPTURE_FLAG_2 @ 
      colorToTeam(%hasColor) @
      *IDMULT_CHAT_CAPTURE_FLAG_3;
   
   %soundFile = "";
   if(%flagTeam == *IDSTR_TEAM_RED)
   {
      %soundFile = "red_flag_cap.wav";
   }
   else if(%flagTeam == *IDSTR_TEAM_BLUE)
   {
      %soundFile = "blue_flag_cap.wav";
   }
   else if(%flagTeam == *IDSTR_TEAM_YELLOW)
   {
      %soundFile = "yel_flag_cap.wav";
   }
   else
   {
      %soundFile = "purp_flag_cap.wav";
   }

   say( 0, 0, %str, %soundFile );      
}

function initScoreBoard()
{
   deleteVariables("$ScoreBoard::PlayerColumn*");
   deleteVariables("$ScoreBoard::TeamColumn*");

   // Player ScoreBoard column headings
   $ScoreBoard::PlayerColumnHeader1 = *IDMULT_SCORE_TEAM;
   $ScoreBoard::PlayerColumnHeader2 = *IDMULT_SCORE_SCORE;
   $ScoreBoard::PlayerColumnHeader3 = *IDMULT_SCORE_FLAGS;
   $ScoreBoard::PlayerColumnHeader4 = "Steals";
   $ScoreBoard::PlayerColumnHeader5 = "Success Rate";
   $ScoreBoard::PlayerColumnHeader6 = *IDMULT_SCORE_CARRIER_KILLS;
   $ScoreBoard::PlayerColumnHeader7 = *IDMULT_SCORE_KILLS;
   $ScoreBoard::PlayerColumnHeader8 = *IDMULT_SCORE_DEATHS;   

   // Player ScoreBoard column functions
   $ScoreBoard::PlayerColumnFunction1 = "getTeam";
   $ScoreBoard::PlayerColumnFunction2 = "getPlayerScore";
   $ScoreBoard::PlayerColumnFunction3 = "getPlayerFlags";
   $ScoreBoard::PlayerColumnFunction4 = "getSteals";
   $ScoreBoard::PlayerColumnFunction5 = "getSuccessRate";
   $ScoreBoard::PlayerColumnFunction6 = "getPlayerCarriersKilled";
   $ScoreBoard::PlayerColumnFunction7 = "getPlayerGenericKills";
   $ScoreBoard::PlayerColumnFunction8 = "getDeaths";


   //Team ScoreBoard column headings
   $ScoreBoard::TeamColumnHeader1 = *IDMULT_SCORE_FLAGS;
   $ScoreBoard::TeamColumnHeader2 = *IDMULT_SCORE_PLAYERS;
   $ScoreBoard::TeamColumnHeader3 = *IDMULT_SCORE_SCORE;
    
   // Team ScoreBoard column functions
   $ScoreBoard::TeamColumnFunction1 = "getTeamFlags";
   $ScoreBoard::TeamColumnFunction2 = "getNumberOfPlayersOnTeam";
   $ScoreBoard::TeamColumnFunction3 = "getTeamScore";

   
   // tell server to process all the scoreboard definitions defined above
   serverInitScoreBoard();   
}

function setFlag(%team, %bool)
{
   %color = teamToColor(%team);
	%flagCountKey = strcat(%color, "FlagCount");
	
	// set flag to visible
	if(%bool)
	{
      dataStore(0, %flagCountKey, 0);
      //not sure if i should capitalize or not yet...ill leave this in anyway
      if(%color=="blue")
      {
         $blueActiveFlag = randomInt(1,$numberOfFlags);
         %txt = "Blue";
      }
      if(%color=="purple")
      {
         $purpleActiveFlag = randomInt(1,$numberOfFlags);
         %txt = "Purple";
      }       	
      say(0,0,"The real "@%color@" flag has been set in a random location!");
      for(%i=1;%i<=$numberOfFlags;%i++)
      {
         setShapeVisibility( getobjectid("Missiongroup\\"@%color@"Flags\\"@%color@%i), true);
      } 
      }
	
	// set flag to non-visible
	else
	{
		dataStore(0, %flagCountKey, 1);
            for(%i=1;%i<=$numberOfFlags;%i++)
            {
               setShapeVisibility( getobjectid("Missiongroup\\"@%color@"Flags\\"@%color@%i), false);
            }             
      }
}

function initGlobalVars()
{
   $scoringFreeze = false;
   
   %playerCount = playerManager::getPlayerCount();
	// clear all points for the players
   for (%p = 0; %p < %playerCount; %p++)
	{
		%player = playerManager::getPlayerNum(%p);
		%player.carriersKilled = 0;
		%player.flagsCollected = 0;
      %player.genericKills = 0;
   }
   

	dataStore(0, "blueFlagsCollected", 0);
	dataStore(0, "redFlagsCollected", 0);
	dataStore(0, "yellowFlagsCollected", 0);
	dataStore(0, "purpleFlagsCollected", 0);

	dataStore(0, "blueCarriersKilled", 0);
	dataStore(0, "redCarriersKilled", 0);
	dataStore(0, "yellowCarriersKilled", 0);
	dataStore(0, "purpleCarriersKilled", 0);

	dataStore(0, "blueFlagCount", 1);
	dataStore(0, "redFlagCount", 1);
	dataStore(0, "yellowFlagCount", 1);
	dataStore(0, "purpleFlagCount", 1);

	dataStore(0, "yellowFlagCarried", 0);
	dataStore(0, "blueFlagCarried", 0);
	dataStore(0, "redFlagCarried", 0);
	dataStore(0, "purpleFlagCarried", 0);

      %color = "Purple";
      for(%i=1;%i<=$numberOfFlags;%i++)
      {
         setShapeVisibility( getobjectid("Missiongroup\\"@%color@"Flags\\"@%color@%i), false);
      } 
      %color = "Blue";
      for(%i=1;%i<=$numberOfFlags;%i++)
      {
         setShapeVisibility( getobjectid("Missiongroup\\"@%color@"Flags\\"@%color@%i), false);
      } 
  	
   $yellowNavPoint = getObjectId("MissionGroup\\yellowBase\\NavPoint");
   $blueNavPoint = getObjectId("MissionGroup\\blueBase\\NavPoint");
   $redNavPoint = getObjectId("MissionGroup\\redBase\\NavPoint");
   $purpleNavPoint = getObjectId("MissionGroup\\purpleBase\\NavPoint");

   $purpleActiveFlag = randomInt(1,$numberOfFlags);
   $blueActiveFlag = randomInt(1,$numberOfFlags);
}

function blueFlagTrigger::trigger::onEnter(%this, %object)
{
   flagTriggerOnEnter(*IDSTR_TEAM_BLUE, %object, %this);
}

function purpleFlagTrigger::trigger::onEnter(%this, %object)
{
   flagTriggerOnEnter(*IDSTR_TEAM_PURPLE, %object, %this);
}

function flagTriggerOnEnter(%team, %object, %trig)
{
   %player = playermanager::vehicleIdToPlayerNum(%object);
   %objname = getObjectName(%trig);
   %purpName = "purpleTrigger"@$purpleActiveFlag;
   %blueName = "blueTrigger"@$blueActiveFlag;
   %color = teamToColor(%team);
   if((%objname==%purpName)||(%objname==%blueName))
   {
      if (getTeam(%object) != %team)
      {
         checkFlagStolen(%team, %object);
      }
      else 
      {     
         if(dataRetrieve(0, strcat(%color, "FlagCount")) == 0) 
         { 
            say(%player,randomInt(500,999),"<jc><f4>You found your flag!");    
         }
         checkFlagRetrieved(%team, %object);
      }
   }
   else if(dataRetrieve(0, strcat(%color, "FlagCount")) == 0) 
   {
      say(%player,randomInt(500,999),"<jc><f4>That's the wrong flag!");
   }
}

//debug
function moveem(){for(%i=1;%i<=$numberOfFlags;%i++){ %trig=getObjectId("Missiongroup\\PurpleFlags\\PurpleTrigger"@%i); %x=getposition(%trig,x); %y=getposition(%trig,y); %z=getposition(%trig,z); %flag=getObjectId("Missiongroup\\PurpleFlags\\purple"@%i);  setposition(%flag,%x,%y,%z);} }